BMapCom.Controller.create(function() {

    var $ = function(q) {
        return document.querySelector(q);
    };

    var pageParamCache = {},
        source = null;

    var sourceDelegate = {
        search: function(tid) {
            var self = this;

            //var ERRNO_SUCCESS = 0;

            //var LOCAL_STORAGE_KEY = "lsk-weekend-detail-" + tid;

            //var resultData = BMapCom.storage.getLocalStorage(LOCAL_STORAGE_KEY);

            //if (resultData) {
                //命中缓存
                //self.onSourceLoadFinish(resultData);
            //} else {

                var domain = "http://client.map.baidu.com/phpui2/?";
                //var domain = "http://db-rdqa-pool291.db01.baidu.com:8004/phpui2/?qt=weekenddetail&themeId=123456&location=12345.67,987.654&from=mapandroid&os=&bduss=&cuid=&channel=&mb=&sv=&bduid=&sign=";
                //var domain = "http://10.95.25.19:8000/phpui2/?";
                //var domain = "http://cp01-centos43-testing005.epc.baidu.com:8004/phpui2/?";

                var param = [
                    'qt=weekenddetail',
                    'from=' + (pageParamCache.os.toLowerCase().indexOf('android') != -1 ? 'mapandroid' : 'mapiphone'),
                    'themeId=' + tid,
                    'location=' + pageParamCache.location,
                    'os=' + pageParamCache.os,
                    'bduss=',
                    'cuid=' + pageParamCache.cuid,
                    'usepass=1',
                    'resid=31',
                    'mb=',
                    'sv=' + pageParamCache.sv,
                    'bduid=',
                    'sign='

                ].join('&');

                var url = domain + param;

                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data.weekend_detail.err_no == 0) {
                            //BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data.weekend_detail.content, 5);
                            self.onSourceLoadFinish(result.data.weekend_detail.content);
                        } else {
                            BMapCom.Loader.jsonp(url)
                                .ok(function(result){
                                    if (result.data.weekend_detail.err_no == 0) {
                                        //BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data.weekend_detail.content, 5);
                                        self.onSourceLoadFinish(result.data.weekend_detail.content);
                                    }
                                });
                        }

                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            //}
        }
    }

    var fixData = function(content) {

        var picWidth = document.documentElement.clientWidth - 24;
        var content = content;
        var items = content.items|| [];
        var list = [];
        //var picUrl = !isWifi ? 'xxx' : 'http://map.baidu.com/maps/services/thumbnails?src=xxx&quality=100&width=yyy';
        for(var i=0,len=items.length;i<len;i++){
            var obj = {};
            var distance = items[i].distance;
            items[i].distance = distance && (distance > 1000 ? (Math.round(distance*10/1000)/10 + 'km') : (distance + 'm')) || '';
            //items[i].pic_url = items[i].pic_url && picUrl.replace('yyy',picWidth).replace('xxx',!isWifi ? items[i].pic_url :  encodeURIComponent(items[i].pic_url)) || "";
            var chunks = items[i].chunks || [];
            for(var j = 0, n=chunks.length;j<n;j++){
                if(chunks[j].type == 'pic'){
                    //chunks[j].content = chunks[j].content && picUrl.replace('yyy',picWidth).replace('xxx',!isWifi ? chunks[j].content : encodeURIComponent(chunks[j].content)) || "";
                }else if(chunks[j].type == 'text'){
                    chunks[j].content = chunks[j].content || "";//.replace(/\n/g,'<br/>')
                }
            }
            obj.distance = items[i].distance;
            obj.uid = items[i].poi_id;
            obj.name = items[i].poi_name;
            obj.address = items[i].address;
            obj.x = items[i].longitude;
            obj.y = items[i].latitude;
            list.push(obj);
        }
        content.items = content.items || [];
        content.list = list;
        content.picUrl = content.pic_url + '';
        //content.pic_url = content.pic_url && picUrl.replace('yyy', document.documentElement.clientWidth).replace('xxx', !isWifi ? content.pic_url : encodeURIComponent(content.pic_url));
        content.semiHeight = Math.floor(document.documentElement.clientWidth * 380 / 640);
        content.poiHeight = Math.floor(document.documentElement.clientWidth * 210 / 585);
        content.shadowHeight = Math.floor(document.documentElement.clientWidth * 380 * 0.525 / 640);
        content.itemShadowHeight = Math.floor((document.documentElement.clientWidth - 18) * 190 * 0.525 / 640);
        content.itemImgHeight = Math.floor((document.documentElement.clientWidth - 18) * 190 / 640);

        //content.expert_uname = 'by 达人 来自赛博利亚星球的变形金刚汽车人第一代首领擎天柱';
        //content.expert_avatar = 'http://himg.bdimg.com/sys/portrait/item/f90d64696e67757378703504.jpg';
        //content.expert_notion = '我是来自赛博利亚星球的变形金刚汽车人第一代首领擎天柱达人，我怕谁~~';
        content.isRecommend = content.expert_uname && content.expert_avatar && content.expert_notion;
        return content;
    }

    //渲染页面
    var renderPage = function(detailPage, detailTpl, detailData) {
        if(!detailData) return;
        var data = fixData(detailData);
        var isAndroid = /android/.test(window.navigator.userAgent.toLowerCase());

        detailPage.append(detailTpl.body(data));
        if(data.isRecommend && data.items.length == 1){
            $('.recommend').style.border = 'none';
            $('.split').style.display = 'block';
        }
        isAndroid && ($('#container').style.marginBottom = '54px');
        Array.prototype.forEach.call(document.querySelectorAll('.text'),function(o,i){
            o.innerText = o.innerText.replace('\n','\r\n');
        });   
        $('#container').style.display = 'block';

        var evt = new BMapCom.EventDelegater($('#container'));
        setTimeout(function(){
            Array.prototype.forEach.call(document.querySelectorAll('[_src]'),function(o,i){
                o.setAttribute('src',o.getAttribute('_src'));
                o.style.height = "auto";
            });    
        },50);

        evt.on('mapJump:tap', function(e) {

            if(isAndroid){
                var entranceParam = {
                    "page": "weekendDetailWebViewPage",
                    "pageParam": {
                        "title": data.title,
                        "index": this.getAttribute('data-index')-0,
                        "list": data.list
                    }
                }
                BMapCom.Kernel.notify('changePage', entranceParam);
            }else{
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "poi_detail_map_page",
                        "base_params": {
                            "title": data.title,
                            "index": this.getAttribute('data-index')-0,
                            "list": data.list
                        }
                    }
                };
                //console.log(requestParam);
                BMapCom.Kernel.notify('request', requestParam);
            }

            BMapCom.Stat.sendOffline("weekenddetailpg.tomapbt", {"da_model": "plugin_weekend"});
        });

        evt.on('poiJump:tap', function(e) {

            if(isAndroid){
                var entranceParam = {
                    "page": "POIDetailWebViewPage",
                    "pageParam": {
                        "uid": this.getAttribute('data-uid')
                    }
                }
                BMapCom.Kernel.notify('changePage', entranceParam);
            }else{
                var requestParam = {
                    "category": "mainmap",
                    "method": BMapCom.ComRequestMethod.DISPATCH,
                    "param": {
                        "target": "basicmap_detail_page",
                        "base_params": {
                            "uid": this.getAttribute('data-uid')
                        }
                    }
                };
                BMapCom.Kernel.notify('request', requestParam);
            }

            BMapCom.Stat.sendOffline("weekenddetailpg.topoibt", {"da_model": "plugin_weekend"});
        });

        evt.on('otherTheme:tap',function(e){
            var that = this;
            setTimeout(function(){
                var themeid = that.getAttribute("data-themeid");

                pageParamCache.themeid = themeid;
                $('#container').parentNode.innerHTML = "";
                var obj = {
                    "da_src": "weekdetailpg",
                    "da_act": "show",
                    "da_trd": "weekend",
                    "da_model" : "plugin_weekend",
                    "themeid" : themeid,
                    "themefrom" : "detailPage"
                };
                BMapCom.Stat.sendOnline(obj);
                source.update(themeid); 
            },0);
        });

        var items = data.items || [];
        var params = {
            "isfav" : data.is_favorite,
            "favnum" : data.favorite_num,
            "themeid" : data.theme_id,
            "share_title" : data.title,
            "share_img" : data.picUrl,
            "share_url" : "http://client.map.baidu.com/weekend/index.html?themeid=" + data.theme_id
        }
        if(items.length == 1){
            params['loc_name'] = items[0].poi_name;
            params['loc_x'] = items[0].longitude;
            params['loc_y'] = items[0].latitude;
        }
        //console.log(JSON.stringify(params));
        BMapCom.Kernel.notify('webPageReady',params);
    }

    var initMethod = function(detailPage, detailTpl) {

        source = new BMapCom.DataSource();
        //绑定数据对象代理
        source
            .delegate(sourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    //var isWifi = true;
                    //BMapCom.SysApi.isWifiConnected(function(isWifi) {
                        renderPage(detailPage, detailTpl, result);
                    //});
                },
                startSourceLoad: function(tid) {
                    this.search(tid);
                }
            });
        //绑定页面事件代理
        detailPage
            .delegate({
                shouldWaiting: function() {
                    return true;
                },
                onCreate: function(pageParam, ready) {

                    pageParamCache = pageParam;

                    //test
                    /*
                    pageParamCache.bduss = '';
                    pageParamCache.location = '12345.67,987.654';
                    pageParamCache.sv = '';
                    pageParamCache.os = '';
                    pageParamCache.cuid = '0653a6a331ef025b12d72ccef06d58b7';
                    source.update(pageParam.themeid);
                    return;
                    */

                    var obj = {
                        "da_src": "weekdetailpg",
                        "da_act": "show",
                        "da_trd": "weekend",
                        "da_model" : "plugin_weekend",
                        "themeid" : pageParam.themeid
                    };
                    pageParam.themefrom && (obj.themefrom = pageParam.themefrom);
                    BMapCom.Stat.sendOnline(obj);

                    BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS], function(runtimeInfo) {
                        pageParamCache.bduss = runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS];
                        var loc = runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION];
                        pageParamCache.location = loc.locX + ',' + loc.locY;
                        BMapCom.SysApi.getSystemInfo([BMapCom.SysApi.SYSTEM_INFO_TYPE.APP_VERSION,BMapCom.SysApi.SYSTEM_INFO_TYPE.OS_NAME,BMapCom.SysApi.SYSTEM_INFO_TYPE.CUID], function(sysInfo) {
                            pageParamCache.sv = sysInfo[BMapCom.SysApi.SYSTEM_INFO_TYPE.APP_VERSION];
                            pageParamCache.os = sysInfo[BMapCom.SysApi.SYSTEM_INFO_TYPE.OS_NAME];
                            pageParamCache.cuid = sysInfo[BMapCom.SysApi.SYSTEM_INFO_TYPE.CUID];
                            source.update(pageParam.themeid);
                        });
                    });
                    
                },
                onDestory: function() {
                    renderContainer.innerHTML = "";
                }
            });

    }
    return {
        initWithPage: initMethod
    }
});
