BMapCom.Template.create("CommentViewTpl", {
list:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,showHead=$data.showHead,$escape=$helpers.$escape,title=$data.title,total=$data.total,showSort=$data.showSort,sort=$data.sort,$string=$helpers.$string,commentsHTML=$data.commentsHTML,showSeeMoreFoot=$data.showSeeMoreFoot,showLoadMoreFoot=$data.showLoadMoreFoot,$out='';$out+='<div class="cv-content">\n        ';
 if (showHead) {
$out+='\n        <div class="cv-head">\n            <span class="cv-head-title">';
$out+=$escape(title);
$out+='</span>\n            ';
 if (total) {
$out+='\n            <span class="cv-head-total">(共';
$out+=$escape(total);
$out+='条)</span>\n            ';
}
$out+='\n            ';
 if (showSort) {
$out+='\n                <div class="cv-head-sort">\n                    <div class="cv-head-sort-selected" data-ek="sort">\n                        <div class="cv-head-sort-selected-value">';
$out+=$escape(sort);
$out+='</div>\n                        <div class="cv-head-sort-arrow" id="cv-head-sort-arrow"></div>\n                    </div>\n                    <div class="cv-head-sort-option-container">\n                        <div value="1" text="默认排序" class="cv-head-sort-option" data-ek="sortValue">默认排序</div>\n                        <div style="border-bottom:1px solid #d9d9d9;margin:0 10px;"></div>\n                        <div value="2" text="时间排序" class="cv-head-sort-option" data-ek="sortValue">时间排序</div>\n                    </div>\n                </div>\n            ';
}
$out+='\n        </div>\n        ';
}
$out+='\n        <ul class="cv-body">\n            ';
$out+=$string(commentsHTML);
$out+='\n        </ul>\n        ';
 if (showSeeMoreFoot) {
$out+='\n        <div class="cv-see-more-foot" data-ek="seeMore">\n            <div class="">查看全部</div>\n            <div class="base-right-arrow cv-right-arrow"></div>\n        </div>\n        ';
}
$out+='\n        ';
 if (showLoadMoreFoot) {
$out+='\n        <div class="cv-load-more-foot" data-ek="loadMore">\n            加载更多评论\n        </div>\n        ';
}
$out+='\n    </div>';
return new String($out);
},
listItem:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,user_logo=$data.user_logo,$escape=$helpers.$escape,username=$data.username,ratingLevel=$data.ratingLevel,rating=$data.rating,price=$data.price,lessContent=$data.lessContent,content=$data.content,cn_name=$data.cn_name,date=$data.date,$out='';$out+='<li class="cv-comment-item">\n        <div class="cv-comment-user">\n            <div class="cv-comment-user-header">\n                ';
 if(user_logo) {
$out+='\n                    <img src="';
$out+=$escape(user_logo);
$out+='" />\n                ';
}else{
$out+='\n                    <img class="cv-default-user-logo" />\n                ';
}
$out+='\n            </div>\n            <div class="cv-comment-user-basic">\n                <div class="cv-comment-user-name">';
$out+=$escape(username);
$out+='</div>\n                <div class="cv-comment-user-rating">\n                    ';
 if(ratingLevel) {
$out+='\n                    <div class="cv-comment-user-rating-star cv-rating-star">\n                        <b class="rating-star cv-rating-star-value" style="width:';
$out+=$escape(ratingLevel);
$out+=';"></b>\n                    </div>\n                    ';
}
$out+='\n                    ';
 if(rating) {
$out+='\n                        <span class="cv-comment-user-rating-text">';
$out+=$escape(rating);
$out+='</span>\n                    ';
}
$out+='\n                    ';
 if(price) {
$out+='\n                        <span class="cv-comment-user-price">人均：￥';
$out+=$escape(price);
$out+='</span>\n                    ';
}
$out+='\n                </div>\n            </div>\n        </div>\n        ';
 if(lessContent) {
$out+='\n            <div class="cv-comment-content">';
$out+=$escape(lessContent);
$out+='\n                <div class="cv-comment-arrow-container" data-ek="arrowDown">\n                    <span class="cv-comment-arrow down"></span>\n                </div>\n            </div>\n            <div class="cv-comment-content" style="display:none;">\n                ';
$out+=$escape(content);
$out+='\n                <div class="cv-comment-arrow-container" data-ek="arrowUp">\n                    <span class="cv-comment-arrow up"></span>\n                </div>\n            </div>\n        ';
}else{
$out+='\n            <div class="cv-comment-content">';
$out+=$escape(content);
$out+='</div>\n        ';
}
$out+='\n        <div class="cv-comment-other">来自';
$out+=$escape(cn_name);
$out+=' ';
$out+=$escape(date);
$out+='</div>\n    </li>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var nth = function(elem, result, dir) {
        // from jQuery
        result = result || 1;
        var num = 0;
        for (; elem; elem = elem[dir]) {
            if (elem.nodeType === 1 && ++num === result) {
                break;
            }
        }
        return elem;
    };
    var nextNode = function(elem) {
        return nth(elem, 2, "nextSibling");
    };
    var prevNode = function(elem) {
        return nth(elem, 2, "previousSibling");
    };

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
    plg.delegate({
        onInstantiate: function(showComments, context) {
            var self = this;

            var commentList = [];
            showComments.comments.forEach(function(comment) {
                commentList.push(self.template.listItem(comment));
            })
            showComments.commentsHTML = commentList.join('');

            var cvBody = context.querySelector('.cv-body');
            if (cvBody) {
                cvBody.innerHTML = cvBody.innerHTML + showComments.commentsHTML;
            } else {
                //首页评论
                context.innerHTML = this.template.list(showComments);
            }

            var cvLoadMoreFoot = context.querySelector('.cv-load-more-foot');
            if (cvLoadMoreFoot && !showComments.showLoadMoreFoot) {
                cvLoadMoreFoot.style.display = 'none';
            }

            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);
            evt.on('arrowDown:tap', function(e) {
                this.parentNode.style.display = 'none';
                var more = nth(this.parentNode, 2, "nextSibling");
                more.style.display = '';
            });
            evt.on('arrowUp:tap', function(e) {
                this.parentNode.style.display = 'none';
                var less = nth(this.parentNode, 2, "previousSibling");
                less.style.display = '';
            });
            evt.on('sort:tap', function(e) {
                var select = context.querySelector('.cv-head-sort-option-container');
                var arrow = context.querySelector('#cv-head-sort-arrow');
                if (select.style.display == "") {
                    select.style.display = "block";
                    arrow.className = "cv-head-sort-arrow arrow-rotate";
                } else {
                    select.style.display = "";
                    arrow.className = "cv-head-sort-arrow";
                }
            });
            evt.on('sortValue:tap', function(e) {
                var value = e.target.getAttribute('value');
                var text = e.target.getAttribute('text');
                var selectValue = context.querySelector('.cv-head-sort-selected-value');
                selectValue.innerHTML = text;
                switch (value) {
                    case "1":
                        selectValue.innerHTML = "默认排序";
                        dispatcher.fire('sortByDefault', []);
                        break;
                    case "2":
                        selectValue.innerHTML = "时间排序";
                        dispatcher.fire('sortByTime', []);
                        break;
                }
                var select = context.querySelector('.cv-head-sort-option-container');
                var arrow = context.querySelector('#cv-head-sort-arrow');
                select.style.display = "";
                arrow.className = "cv-head-sort-arrow";
            });
            evt.on('seeMore:tap', function(e) {
                dispatcher.fire('seeMoreClick', []);
            });
            evt.on('loadMore:tap', function(e) {
                dispatcher.fire('loadMoreClick', []);
            });

            return {
                'event': dispatcher,
                'refresh': function(commentsData) {
                    var commentList = [];
                    commentsData.comments.forEach(function(comment) {
                        commentList.push(self.template.listItem(comment));
                    });
                    commentsData.commentsHTML = commentList.join('');

                    var cvBody = context.querySelector('.cv-body');
                    if (cvBody) {
                        cvBody.innerHTML = cvBody.innerHTML + commentsData.commentsHTML;
                    } else {
                        //首页评论
                        context.innerHTML = this.template.list(commentsData);
                    }
                },
                'clear': function() {
                    var cvBody = context.querySelector('.cv-body');

                    cvBody.innerHTML = "";
                }
            };
        }
    });

    return plg;
});
