BMapCom.Template.create("./plugin/CommentView/CommentViewTpl", {
list:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$string=$helpers.$string,commentsHTML=$data.commentsHTML,$out='';$out+='<div class="cv-content">\n        <div class=\'cv-title\'>\n            <span class=\'cv-title-img\'></span>\n            <span class=\'cv-title-title\'>网友评论</span>\n        </div>\n        <ul class="cv-body">\n            ';
$out+=$string(commentsHTML);
$out+='\n        </ul>\n        <div class="cv-load-more-foot" data-ek="loadMore" style="display: none;">\n            <span class="cv-load-icon"></span>\n            <span class="cv-load-text">加载更多评论</span>\n        </div>\n    </div>';
return new String($out);
},
listItem:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,username=$data.username,ratingLevel=$data.ratingLevel,rating=$data.rating,price=$data.price,lessContent=$data.lessContent,content=$data.content,cn_name=$data.cn_name,date=$data.date,$out='';$out+='<li class="cv-comment-item">\n        <div class="cv-comment-user-basic">\n            <div class="cv-comment-user-name text-ellipsis">';
$out+=$escape(username);
$out+='</div>\n            <div class="cv-comment-user-rating">\n                ';
 if(ratingLevel) {
$out+='\n                <div class="cv-comment-user-rating-star cv-rating-star">\n                    <b class="rating-star cv-rating-star-value" style="width:';
$out+=$escape(ratingLevel);
$out+=';"></b>\n                </div>\n                ';
}
$out+='\n                ';
 if(rating) {
$out+='\n                <span class="cv-comment-user-rating-text">';
$out+=$escape(rating);
$out+='</span>\n                ';
}
$out+='\n                ';
 if(+price) {
$out+='\n                <span class="cv-comment-user-price">人均&nbsp;&yen;&nbsp;';
$out+=$escape(price);
$out+='</span>\n                ';
}
$out+='\n            </div>\n        </div>\n        ';
 if(lessContent) {
$out+='\n            <div class="cv-comment-content" data-ek="arrowDown">';
$out+=$escape(lessContent);
$out+='\n                <div class="cv-comment-arrow-container">\n                    <span class="cv-comment-arrow down"></span>\n                </div>\n            </div>\n            <div class="cv-comment-content" data-ek="arrowUp" style="display:none;">\n                ';
$out+=$escape(content);
$out+='\n                <div class="cv-comment-arrow-container">\n                    <span class="cv-comment-arrow up"></span>\n                </div>\n            </div>\n        ';
}else{
$out+='\n            <div class="cv-comment-content">';
$out+=$escape(content);
$out+='</div>\n        ';
}
$out+='\n        <div class="cv-comment-other">来自';
$out+=$escape(cn_name);
$out+=' ';
$out+=$escape(date);
$out+='</div>\n    </li>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var domainUrl = BMapCom.config('domain.detail') + '?qt=ugccmtlist&from=mapclient',
        gParam, gContext, gInstance;
    var sreviewUrl = 'http://map.baidu.com/detail?qt=sreview';

    var fixComment = function(review, total) {
        var showMore = false;

        if (review && review.length) {
            if (gParam.startIndex == 1 && total > 10) {
                showMore = true;
            } else if (gParam.startIndex > 1 && (gParam.startIndex * gParam.maxResults) < total) {
                showMore = true;
            }
            var fixedData = {
                'showLoadMore': showMore,
                'comments': []
            };
            fixedData.comments = review.map(function(commentItem) {
                commentItem.username = commentItem.user_name || (commentItem.cn_name + '网友');
                commentItem.ratingLevel = (commentItem.rating) ? commentItem.rating * 20 + "%" : ((commentItem.overall_rating) ? commentItem.overall_rating * 20 + "%" : 0);
                commentItem.rating = (commentItem.rating) ? commentItem.rating : ((commentItem.overall_rating) ? commentItem.overall_rating : 0);
                commentItem.content = commentItem.content.replace(/<\/?em.*?>/g, "");
                if (commentItem.content.length > 50) {
                    commentItem.lessContent = commentItem.content.substr(0, 50) + '...';
                }
                return commentItem;
            });
            return fixedData;
        }
    };

    var searchDelegator = {
        search: function(opts) {
            var self = this,
                param,
                url;

            param = [
                'uid=' + opts.uid,
                'type=cater',
                'orderBy=' + opts.orderBy,
                'pageIndex=' + opts.startIndex,
                'pageCount=' + opts.maxResults
            ].join('&');

            url = domainUrl + '&' + param;
            return BMapCom.Loader.jsonp(url)
                .ok(function(result) {
                    if (result.data &&
                        result.data.errorNo == 0  &&
                        result.data.comment.comment_num !== 0) {
                        self.onSourceLoadFinish(result.data);
                    }
                })
                .error(function() {
                    self.onSourceLoadFailed();
                });
        }
    };

    var ugcCommentSource = new BMapCom.DataSource();
    ugcCommentSource
        .delegate(searchDelegator)
        .delegate({
            startSourceLoad: function(param) {
                this.search(param);
            },
            onSourceLoadFinish: function(result) {
                if (!result.comment.comment_num) {
                    return;
                } else {
                    gContext.style.display = "";
                }

                fixData = fixComment(result.comment.comment_list, result.comment.comment_num);

                switch (gParam.renderType) {
                    case 'renderBySort':
                        gContext.querySelector('.cv-body').innerHTML = "";
                        break;
                    default:
                        break;
                }
                refresh(fixData);

            },
            onSourceLoadFailed: function() {}
        });

    var sreviewSource = new BMapCom.DataSource();
    sreviewSource
        .delegate({
            search: function(opts) {
                var self = this,
                    param,
                    url;

                param = [
                    "wd=" + opts.wd,
                    "comid=" + encodeURIComponent(opts.commentIds)
                ].join('&');

                url = sreviewUrl + '&' + param;
                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data) {
                            self.onSourceLoadFinish(result.data);
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            },
            startSourceLoad: function(param) {
                this.search(param);
            },
            onSourceLoadFinish: function(result) {

                fixData = fixComment(result, 0);

                refresh(fixData);
            },
            onSourceLoadFailed: function() {}
        });

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    function hasClass(elem, cls) {
        return elem.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
    }

    function addClass(elem, cls) {
        if (!hasClass(elem, cls)) {
            elem.className += " " + cls;
        }
    }

    function removeClass(elem, cls) {
        if (hasClass(elem, cls)) {
            var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
            elem.className = elem.className.replace(reg, ' ');
        }
    }

    function refresh(commentsData) {
        if (!commentsData || !commentsData.comments.length) {
            return ;
        }
        var commentList = [],
            cvLoadMore = gContext.querySelector('.cv-load-more-foot'),
            cvLoadMoreText = gContext.querySelector('.cv-load-more-foot .cv-load-text');

        if (commentsData.showLoadMore && cvLoadMore) {
            cvLoadMore.style.display = 'block';
            removeClass(cvLoadMore, 'cv-loading');
            cvLoadMoreText.textContent = '加载更多评论';
        } else {
            cvLoadMore && (cvLoadMore.style.display = 'none');
        }

        commentsData.comments.forEach(function(comment) {
            commentList.push(gInstance.template.listItem(comment));
        });

        if (!commentList.length) {
            return;
        }
        commentsData.commentsHTML = commentList.join('');

        var cvBody = gContext.querySelector('.cv-body');
        if (cvBody) {
            cvBody.innerHTML = cvBody.innerHTML + commentsData.commentsHTML;
        } else {
            //首页评论
            context.innerHTML = this.template.list(commentsData);
        }
    }

    function clear() {
        var cvBody = gContext.querySelector('.cv-body');

        cvBody.innerHTML = "";

        gParam.startIndex = 1;
        gParam.maxResults = 10;

        gContext.querySelector('.cv-load-more-foot').style.display = "none";
    }

    plg.delegate({
        onInstantiate: function(options, context) {

            options.startIndex = options.startIndex || 1;
            options.starLevel = options.starLevel || 0;
            options.maxResults = options.maxResults || 10;
            options.orderBy = options.orderBy || 3;

            gParam = options;

            gContext = context;

            gInstance = this;

            context.innerHTML = this.template.list(gParam);

            ugcCommentSource.update(gParam);

            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);
            evt.on('arrowDown:tap', function(e) {
                this.style.display = 'none';
                this.nextElementSibling.style.display = '';
            });
            evt.on('arrowUp:tap', function(e) {
                this.style.display = 'none';
                this.previousElementSibling.style.display = '';
            });
            evt.on('loadMore:tap', function(e) {
                addClass(context.querySelector('.cv-load-more-foot'), 'cv-loading');
                context.querySelector('.cv-load-more-foot .cv-load-text').textContent = '加载中...';

                gParam.startIndex++;

                ugcCommentSource.update(gParam);

                dispatcher.fire('loadMoreClick', []);

                BMapCom.Stat.sendOnline({
                    "uid": gParam.uid,
                    "da_src": "poidetailpg.commentmorebt",
                    "da_act": "click",
                    "da_model": "plugin_cater",
                    "da_trd": "cater"
                });
            });

            return {
                event: dispatcher,
                reload: function() {
                    this.clear();
                    ugcCommentSource.update(gParam);
                },
                clear: clear,
                sreview: function(wd, commentIds) {
                    this.clear();
                    sreviewSource.update({
                        wd: wd,
                        commentIds: commentIds
                    });
                }
            };
        }
    });

    return plg;
});
