BMapCom.Template.create("ConcernViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,registed=$data.registed,$out='';if(registed){
$out+='\n		<span class=\'ConTab followed\' data-ek="concern">已关注</span>\n	';
}else{
$out+='\n		<span class=\'ConTab\' data-ek="concern">+关注</span>\n	';
}
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) { 
	var online_api = "http://client.map.baidu.com/phpui2/?";
	//var online_api = "http://cq01-rdqa-pool190.cq01.baidu.com:8002/phpui2/?"; // rd-address
	//var online_api = "10.100.46.93:8000/phpui2/?";	// qa-address

	var _bduss = null;
	var eventBinded = false;
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

	var PluginStatus = {
		NOT_LOGGIN:    0,
		NOT_CONCERNED: 1,
		CONCERNED:     2
	}; 

	function ConcernManager(container, tpl){
		var tab = document.querySelector(".ConTab");
		var status = PluginStatus.NOT_LOGGIN;

		this.setStatus = function(st){
			status = st;	
		} 
		this.render = function(){
			var html = "";
			var data = {}
			switch(status){
				case PluginStatus.NOT_LOGGIN:
				case PluginStatus.NOT_CONCERNED:
					data.registed = 0; 
					break;
				case PluginStatus.CONCERNED:
					data.registed = 1;
					break;
			}
			container.innerHTML = tpl.body(data);
		} 
		function needfresh(){
			BMapCom.Kernel.notify('needFresh', {}, function(){});
		} 
		function notloginhandler(id){
			var p = new BMapCom.Promise(function(resolve){
				BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, function(bduss){
					_bduss = bduss;
					resolve(bduss);
				}); 
			}).then(function(bduss){ 
				if(!bduss){
					var request_param_an = { 
						"category": "mainmap",
						"method": BMapCom.ComRequestMethod.QUERY,
						"param":{
							"target": "request_login_info",
							"base_params":{
								"login_page": "normal_login"
							}
						}
					};
					var request_param_ip = { 
						"category": "mainmap",
						"method": BMapCom.ComRequestMethod.DISPATCH,
						"param":{
							"target": "map_lgin_page",
							"base_params":{
								"logintype": 1
							}
						}
					};
					BMapCom.Kernel.notify('request', request_param_ip, function(result) {});
					BMapCom.Kernel.notify('request', request_param_an, function(result) {}); 
				}else{
					concernhandler(id);	
				}
			}); 
		}
		function concernhandler(id){
			var params = [
				'qt=favorite',
				'type=up',
				'key=zhidahao',
				'subkey=follow',
				'rp_format=json',
				'from=webview',
			]; 
			var tab = document.querySelector(".ConTab");
			tab.innerHTML = "请稍后";
			if(_bduss){
				BMapCom.Loader.post({url: online_api + params.join("&"), postdata: {theme_id: id, BDUSS: _bduss}}, function(result){
					//var result = {"result":{"type":912,"error":0},"favorite":{"error":0,"msg":"","data":{"theme_id":"b66ea05c10c6429eca291576","status":1}}};
					if(result.favorite && result.favorite.error == 0){ 
						var tab = document.querySelector(".ConTab");
						var fav_info = result.favorite;
						if(fav_info.data.status == 1){
							container.querySelector(".ConTab").innerHTML = "已关注";	
							tab.className = "ConTab followed";
							status = PluginStatus.CONCERNED;
						}else{
							container.querySelector(".ConTab").innerHTML = "+关注";	
							tab.className = "ConTab";
							status = PluginStatus.NOT_CONCERNED; 
						}
						needfresh();
					}
				}); 
			}
		}
		function cancelhandler(id){
			var params = [
				'qt=favorite',
				'type=cancel',
				'key=zhidahao',
				'subkey=follow'
			];
			var tab = document.querySelector(".ConTab");
			tab.innerHTML = "请稍后";
			if(_bduss){
				BMapCom.Loader.post({url: online_api + params.join("&"), postdata: {theme_id: id, BDUSS:_bduss}}, function(result){
					//var result = {"result":{"type":912,"error":0},"favorite":{"error":0,"msg":"","data":{"theme_id":"b66ea05c10c6429eca291576","status":0}}};
					if(result.favorite.error == 0){
						var favorite_info = result.favorite;
						var tab = document.querySelector(".ConTab");
						if(favorite_info.data.status == 0){
							container.querySelector(".ConTab").innerHTML = "+关注";	
							tab.className = "ConTab";
							status = PluginStatus.NOT_CONCERNED;
						}else{
							container.querySelector(".ConTab").innerHTML = "已关注";	
							tab.className = "ConTab followed";
							status = PluginStatus.CONCERNED;
						}
						needfresh();
					}
				}); 
			}
		}
		this.eventBind = function(id){
			if(!eventBinded){
				var evt = new BMapCom.EventDelegater(container); 
				evt.on("concern:tap", function(e){
					switch(status){
						case PluginStatus.NOT_LOGGIN:
							notloginhandler(id);
							break;
						case PluginStatus.NOT_CONCERNED:
							concernhandler(id);
							break;
						case PluginStatus.CONCERNED:
							cancelhandler(id);
							break;
					} 
				});
			}
			eventBinded = true;
		}
	}

	plg.delegate({
		onInstantiate: function(paramObj, container){ 
			var that = this;
			var renderPage = new ConcernManager(container, that.template);
			renderPage.render(); 
			var params = [
				'qt=favorite',
				'type=id_cnt',
				'rp_format=json',
				'from=webview',
				'key=zhidahao',
				'subkey=follow',
				'ids=' + paramObj.uid,
			];
			new BMapCom.Promise(function(resolve){ 
				if(!_bduss){
					BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, function(result){
						resolve(result);
					});
				}else{ 
					resolve(_bduss);
				}
			}).then(function(bduss){
				if(bduss){ 
					_bduss = bduss;
					BMapCom.Loader.post({url:online_api + params.join('&'), postdata:{BDUSS:_bduss}}, function(result){ 
						if(result.favorite_info && result.favorite_info.error == 0){
							// not concerned about it
							var data = result.favorite_info.data[0];
							var status = data["details"][0]["if_do"]; 
							if(status == 0){
								renderPage.setStatus(PluginStatus.NOT_CONCERNED);
							}else{
								renderPage.setStatus(PluginStatus.CONCERNED);
							}
							renderPage.render();
							renderPage.eventBind(paramObj.uid);
						}
					});
				}else{
					renderPage.eventBind(paramObj.uid); 
				}
			}); 
			
			BMapCom.Kernel.listen('refresh', function(param){
				BMapCom.Loader.post({url:online_api + params.join('&'), postdata:{BDUSS:_bduss}}, function(result){ 
					if(result.favorite_info && result.favorite_info.error == 0){
						// not concerned about it
						var data = result.favorite_info.data[0];
						var status = data["details"][0]["if_do"]; 
						if(status == 0){
							renderPage.setStatus(PluginStatus.NOT_CONCERNED);
						}else{
							renderPage.setStatus(PluginStatus.CONCERNED);
						}
						renderPage.render();
					}
				});
			});
		}
	});
	return plg;
});
