BMapCom.Template.create("./plugin/MasterView/MasterViewTpl", {
list:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,type_text=$data.type_text,master_name=$data.master_name,master_avatar=$data.master_avatar,master_notion=$data.master_notion,recommend_text=$data.recommend_text,more_pics=$data.more_pics,i=$data.i,length=$data.length,$out='';$out+='<header class="with-icon with-right-arrow" data-ek="goTopicDetail">\n        ';
$out+=$escape( type_text);
$out+='\n    </header>\n    <section>\n        ';
 if (master_name) { 
$out+='\n        <div class="master-info clearfix">\n            <img src="';
$out+=$escape( master_avatar);
$out+='" alt="">\n            <p class="name">';
$out+=$escape( master_name);
$out+='</p>\n            <p class="desc">';
$out+=$escape( master_notion);
$out+='</p>\n        </div>\n        ';
 } 
$out+='\n        <p>推荐理由: ';
$out+=$escape( recommend_text);
$out+='</p>\n        ';
 if (more_pics && more_pics.length) { 
$out+='\n            <ul>\n            ';
 for (var i = 0, length = more_pics.length; i < length; i++) { 
$out+='<li><img src="';
$out+=$escape( more_pics[i]);
$out+='" alt=""></li>';
 } 
$out+='\n            </ul>\n        ';
 } 
$out+='\n    </section>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var domainUrl = 'http://map.baidu.com/cater?qt=cater_master&from=webview',
        gParam, gContext, gInstance, gResult;


    var searchDelegator = {
        search: function(opts) {
            var self = this;
            BMapCom.SysApi.getSystemInfo(BMapCom.SysApi.SYSTEM_INFO_TYPE.CUID, function(cuid) {
                var param,
                    url;
                //cuid = "xxx";
                param = [
                    'uid=' + opts.uid,
                    'city_id=' + opts.cityId,
                    'cuid=' + cuid,
                    'tver=1'
                ].join('&');

                url = domainUrl + '&' + param;
                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data && result.data.errno == 0) {
                            self.onSourceLoadFinish(result.data.data);
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            });
        }
    };

    var masterSource = new BMapCom.DataSource();
    masterSource
        .delegate(searchDelegator)
        .delegate({
            startSourceLoad: function(param) {
                this.search(param);
            },
            onSourceLoadFinish: function(result) {

                if (!result.topic_content) {
                    return;
                }
                gContext.style.display = "";
                gResult = result;

                if (result.more_pics) {
                    result.more_pics = result.more_pics.map(function(item) {
                        return BMapCom.util.getThumbUrl(item, 132, 132);
                    });
                }
                gContext.innerHTML = gInstance.template.list(result);

                _log({
                    "da_src": result.type === "chengmi" ? "poidetailpg.chengmirecommend" : "poidetailpg.masterrecommend",
                    "da_act": "show"
                });
            },
            onSourceLoadFailed: function() {}
        });

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    
    plg.delegate({
        onInstantiate: function(options, context) {
            gInstance = this;
            gContext = context;
            gParam = options;

            masterSource.update(options);
            
            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);

            evt.on("goTopicDetail:tap", function() {
                _log(gResult.type === "chengmi" ? "poidetailpg.chengmirecommendbt" : "poidetailpg.masterrecommendbt");
                if (gResult.type === "chengmi") {
                    BMapCom.Kernel.notify('changePage', {
                        "page": "topicDetailPage",
                        "pageParam": {
                            "type": "master",
                            "from": "caterPoiDetailPage",
                            "options": gResult
                        }
                    });
                } else {
                    BMapCom.Kernel.notify('changePage', {
                        "page": "topicDetailPage",
                        "pageParam": {
                            "type": "master",
                            "from": "caterPoiDetailPage",
                            "tid": gResult.topic_content[0].theme,
                            "cid": gParam.cityId
                        }
                    });
                }
            });
            return {
                event: dispatcher
            };
        }
    });

    return plg;
});
