BMapCom.Template.create("NearbySearchViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,moreSources=$data.moreSources,i=$data.i,n=$data.n,$escape=$helpers.$escape,$out='';$out+='<div class="nearby-search-and-more-source-content">\n        ';
if (moreSources.length) {
$out+='\n        <div class="nearby-search-content">\n        ';
} else {
$out+='\n        <div class="nearby-search-content-no-bottom"> \n        ';
}
$out+='\n            <p class="nearby-search-title">在周边找</p>\n            <div class="nearby-search-items">\n                <div class="nearby-search-item nearby-search-delicacy-icon" data-ek="delicacy">\n                    美食\n                    <div class="nearby-search-divider"></div>\n                </div>\n                <div class="nearby-search-item nearby-search-snack-icon" data-ek="snack">\n                    小吃\n                    <div class="nearby-search-divider"></div>\n                </div>\n                <div class="nearby-search-item nearby-search-hotel-icon" data-ek="hotel">\n                    酒店\n                    <div class="nearby-search-divider"></div>\n                </div>\n                <div class="nearby-search-item nearby-search-bus-icon" data-ek="bus">\n                    公交站\n                    <div class="nearby-search-divider"></div>\n                </div>\n                <div class="nearby-search-item nearby-search-more-icon" data-ek="more">\n                    更多\n                </div>\n            </div>\n        </div>\n        ';
if (moreSources.length) {
$out+='\n        <div class="more-source-content">\n            <p class="more-source-title">查看更多来源</p>\n            <div class="more-source-items">\n                ';
for (i = 0, n = moreSources.length; i < n; i++ ){ 
$out+='\n                    <div class="more-source-item" style="background-image:url(http://map.baidu.com/fwmap/upload/place/icon/';
$out+=$escape(moreSources[i].name);
$out+='/50.png)" data-ek="moreSource" data-value="';
$out+=$escape(moreSources[i].url);
$out+='" data-from="';
$out+=$escape(moreSources[i].name);
$out+='"></div>\n                ';
}
$out+='\n            </div>\n        </div>\n        ';
}
$out+='\n    </div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    plg.delegate({
        onInstantiate: function(poi, context) {
            var self = this;

            var fixedData = {};
            fixedData.moreSources = [];
            if (poi.ext && poi.ext.detail_info) {
                var di = poi.ext.detail_info;
                var ri = poi.ext.rich_info;

                var links = di.link;
                links && links.forEach(function(item) {
                    if (item.url_mobilephone) {
                        fixedData.moreSources.push({
                            'name': item.name,
                            'url': item.url_mobilephone || ''
                        })
                    }
                })
            };


            context.innerHTML = this.template.body(fixedData);

            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);
            evt.on('delicacy:tap', function(e) {
                dispatcher.fire('delicacyClick', []);
            });
            evt.on('snack:tap', function(e) {
                dispatcher.fire('snackClick', []);
            });
            evt.on('hotel:tap', function(e) {
                dispatcher.fire('hotelClick', []);
            });
            evt.on('bus:tap', function(e) {
                dispatcher.fire('busClick', []);
            });
            evt.on('more:tap', function(e) {
                dispatcher.fire('moreClick', []);
            });
            evt.on('moreSource:tap', function(e) {
                var url = this.getAttribute('data-value');
                var from = this.getAttribute('data-from');
                //alert(from);
                if (url) {
                    dispatcher.fire('moreSourceClick', [url,from]);
                }
            });

            return dispatcher;
        }
    });

    return plg;
});