BMapCom.Template.create("./plugin/RankListView/RankListViewTpl", {
list:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$out='';return new String($out);
},
item:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,i=$data.i,list=$data.list,$escape=$helpers.$escape,encodeURIComponent=$data.encodeURIComponent,circle=$data.circle,showMore=$data.showMore,$out=''; for (var i = 0; i < list.length; i++) {
$out+='\n<li data-ek="goDetail" data-uid="';
$out+=$escape(list[i].uid);
$out+='" data-name="';
$out+=$escape(list[i].title);
$out+='" data-from="rankList" class="ranklist-item">\n    <img src=';
 if (list[i].pic_url) {
$out+='"http://map.baidu.com/maps/services/thumbnails?src=';
$out+=$escape(encodeURIComponent(list[i].pic_url));
$out+='&width=200&height=200&align=center"';
} else {
$out+='"style/img/cater_nodata.png"';
 } 
$out+='alt="" width="75" height="58">\n    <div class="desc">\n        <h2>';
$out+=$escape(list[i].title);
$out+='</h2>\n        <p>\n            ';
 if (+list[i].score) {
$out+='\n                <span class="rating-star">\n                    <b class="rating-star-value" style="width:';
$out+=$escape( (+list[i].score).toFixed(1)*20);
$out+='%;"></b>\n                </span>\n                <span class="star-text">';
$out+=$escape( (+list[i].score).toFixed(1) + "分");
$out+='</span>\n            ';
 } 
$out+='\n            ';
 if (list[i].price) {
$out+='\n                <span class="price">人均: <font color="#F54336">&yen;';
$out+=$escape(list[i].price.substring(0, list[i].price.length-2));
$out+='</font></span>\n            ';
}
$out+='\n        </p>\n        <p class="f12 mt3 cl-gray">\n            <span class="distance">';
$out+=$escape(list[i].dis > 1000 ? (list[i].dis/1000).toFixed(1) + "km" : list[i].dis > 0 ? list[i].dis + "m": "");
$out+='</span>\n            ';
$out+=$escape( circle);
$out+=' ';
$out+=$escape( list[i].tag);
$out+='\n        </p>\n    </div>\n</li>\n';
 } 
$out+='\n';
 if (showMore) { 
$out+='\n    <div class="more-ranklist" id="caterRecommendMore" data-ek="goTopList"><span>查看更多</span><i class="toggle-arrow-right"></i></div>\n';
 } 
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var gParam, gContext, gInstance;


    var searchDelegator = {
        search: function(opts) {
            var self = this;

            BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID], function(runtimeInfo) {
                var domain = "http://client.map.baidu.com/detail?",
                    type = ['resou_rank', 'haoping_rank', 'biaosheng_rank'];
                var param = [
                    'qt=ranklist',
                    'city_id=' + runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID],
                    'point_x=' + runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locX,
                    'point_y=' + runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locY,
                    'aoi_name=' + gParam.aoiName,
                    'indus=' + gParam.indus,
                    'type=' + type[gParam.rank],
                    'pn=' + 0
                ].join('&');

                return BMapCom.Loader.jsonp(domain + param)
                    .ok(function(result) {
                        if (result.data.errno === 0) {
                            self.onSourceLoadFinish(result.data.data);
                        } else {
                            BMapCom.Loader.jsonp(url)
                                .ok(function(result){
                                    if(result.data.errno === 0){
                                        self.onSourceLoadFinish(result.data.data);
                                    }
                                });
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            });
        }
    };

    var masterSource = new BMapCom.DataSource();
    masterSource
        .delegate(searchDelegator)
        .delegate({
            startSourceLoad: function(param) {
                this.search(param);
            },
            onSourceLoadFinish: function(result) {
                if (!result) {
                    return;
                }
                var list = result.content.slice(0, 3);
                gContext.innerHTML = gInstance.template.item({
                    list: list,
                    showMore: true,
                    encodeURIComponent: encodeURIComponent,
                    circle: result.circle_name
                });
                _log({
                    "da_src": "poidetailpg.ranklist",
                    "da_act": "show"
                });
            },
            onSourceLoadFailed: function() {}
        });

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    
    plg.delegate({
        onInstantiate: function(options, context) {
            gInstance = this;
            gContext = context;
            gParam = options;
            masterSource.update(options);
            
            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);
            evt.on("goDetail:tap", function() {

                var entranceParam = {
                    "page": "detailPage",
                    "pageParam": {
                        "uid": this.getAttribute("data-uid"),
                        "from": "caterDetailPage",
                        "option": {
                            
                        }
                    }
                };

                BMapCom.Kernel.notify('changePage', entranceParam);

                _log("poidetailpg.rankpoilistbt");
            });
            return {
                event: dispatcher
            };
        }
    });

    return plg;
});
