BMapCom.Template.create("ShoppingViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,i=$data.i,list=$data.list,$escape=$helpers.$escape,$out='';$out+='<div class="shopping-box">\n		<div class="shopping-container">\n			<div class="shopping-title" data-ek="slideShop"><span style="padding:8px 0 0 10px;">橱窗商品</span></div>\n			<div class="shopping-padding"><!--撑大空间塞内容-->\n				<div class="shopping-content">\n					';
for(var i = 0; i < list.length; i++){
$out+='\n						<div class="shopping-content-container">\n							<img src="';
$out+=$escape(list[i].logo_pic);
$out+='"></img>\n							<div class="shopping-content-container-title">';
$out+=$escape(list[i].name);
$out+='</div>\n							';
if(list[i].discount_price >= 0 && list[i].price > list[i].discount_price){
$out+='\n								<div class="discount">\n									';
if(list[i].discount_price > -1){
$out+='\n									<span class="discount-price">￥';
$out+=$escape(list[i].discount_price);
$out+='</span>\n									';
}
$out+='\n									<span class="origin-price">原价<del class=\'price\'>￥';
$out+=$escape(list[i].price);
$out+='</del></span>\n								</div>\n							';
}else{
$out+='\n								<div class="discount">\n									<span class="discount-price">￥';
$out+=$escape(list[i].price);
$out+='</span>\n								</div>\n							';
}
$out+='\n						</div>	\n					';
}
$out+='\n				</div>\n				<div class="shopping-content-shadow">\n				</div> \n			</div>\n		</div>\n		<div class="shopping-pannel">\n		';
if(list.length > 1){
$out+='\n			';
for(var i = 0; i < list.length; i++){
$out+='\n				';
if(i == 0){
$out+='\n					<div class="shopping-pannel-item current-item" index=';
$out+=$escape(i);
$out+=' ></div>\n				';
}else{
$out+='\n					<div class="shopping-pannel-item" index=';
$out+=$escape(i);
$out+=' ></div>\n				';
}
$out+='\n			';
}
$out+='\n		';
}
$out+='\n		</div>\n	</div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
	var online_api = "http://elbc.baidu.com/zdh/commodity/getlist?";
	//var online_api = "http://cq02-map-sv-control04.cq02.baidu.com:8999/zdh/commodity/getlist?";

	function styleFix(){
		var elems = document.querySelectorAll(".shopping-content-container");
		var container = document.querySelector(".shopping-container");
		var containerWidth = container.clientWidth;
		for(var i = 0; i < elems.length; i++){
			elems[i].style.width = containerWidth + "px";
		}
	}
	
	function fixData(list){
		var result = [];
		list = list.splice(0, 5);
		list.forEach(function(item){ 
			item.price = parseFloat(item.price);
			item.discount_price = parseFloat(item.discount_price);
			result.push({
				"name": item.name || '', 
				"description": item.description.substr(0, 25) || '',
				"logo_pic": item.logo_pic || '',
				"price": item.price,
				"discount_price": typeof item.discount_price == "number" ? item.discount_price : -1
			});	
		});
		return result;
	}

	function playAnimation(speed){ 
		var tab = document.querySelector(".shopping-container");
		var tab1 = document.querySelector(".shopping-content");
		var tab2 = document.querySelector(".shopping-content-shadow");
		var container = document.querySelector(".shopping-container");
		var containerWidth = container.clientWidth;
		var pannelElems = document.querySelectorAll(".shopping-pannel-item");
		var slidePad = document.querySelector(".shopping-title");
		// 三个interval变量分别是走马灯、左移动画、右移动画
		var MyMar, LeftMar, RightMar;  
		// swipeLock 为滑动操作锁、playLock为动画锁，inter为走马灯间隔时间。
		var swipeLock = false, playLock = false, inter = 6000, count = 0;
		var size = pannelElems.length, timer;
		tab2.innerHTML = tab1.innerHTML;

		/*
		 * 切换图片下的小圆圈
		 */
		function setAnimationSwitch(){
			var cn;
			for(var i = 0; i < pannelElems.length; i++){
				cn = pannelElems[i].className;
				if(i == count && !/current-item/.test(cn))
					pannelElems[i].className = cn + (" current-item");
				if(i != count)
					pannelElems[i].className = cn.replace(/current-item/, '');
			}
		}

		function Marquee(){
			if(swipeLock || playLock) return;
			if(tab2.offsetWidth - tab.scrollLeft <= 0) tab.scrollLeft -= tab1.offsetWidth
			for(var i = 0; i < 5; i++){
				tab.scrollLeft++; 
				if(tab.scrollLeft > 0 && tab.scrollLeft % containerWidth == 0){
					count = tab.scrollLeft / containerWidth;
					count = count == size ? 0 : count;
					setAnimationSwitch();
					clearInterval(MyMar);
					setTimeout(function(){
						MyMar = setInterval(Marquee, speed); 
					}, inter); 
					break;
				} 
			}
		}

		//几秒后发生,造成首张图片停顿几秒
		setTimeout(function(){
			MyMar = setInterval(Marquee, speed); 
		}, inter);

		var evt = new BMapCom.EventDelegater(container); 
		/*
		 * 每次完成动画，解开滑动锁、并且开始计时，
		 * 计时目的在于避免连续的滑动操作造成解开动画锁时机不对。 
		 */
		evt.on("slideShop:swipeLeft", function(e){
			if(swipeLock) return;
			swipeLock = true;
			playLock = true; 
			BMapCom.Stat.sendOnline({
				'da_src': 'shoppingpg.slideimage',
				'da_act': 'show',
				'da_trd': 'zhidahao'
			});
			if(tab.scrollLeft == containerWidth * size) tab.scrollLeft = 0;
			var targetScrollLeft = count == size - 1 ? containerWidth * size : (count + 1) * containerWidth; 	
			LeftMar = setInterval(function(){
				for(var i = 0; i < 5; i++){
					if(tab.scrollLeft == targetScrollLeft){
						clearInterval(LeftMar);
						count = (count + 1) % size;
						setAnimationSwitch();
						swipeLock = false; 
						timer = (new Date()).getTime();
						setTimeout(function(){
							if((new Date()).getTime() - timer >= inter)
								playLock = false;
						}, inter);
						break;
					} 
					tab.scrollLeft++;
				}
			}, speed);
		});
		evt.on("slideShop:swipeRight", function(e){ 
			if(swipeLock) return;
			swipeLock = true;
			playLock = true;
			BMapCom.Stat.sendOnline({
				'da_src': 'shoppingpg.slideimage',
				'da_act': 'show',
				'da_trd': 'zhidahao'
			});
			if(tab.scrollLeft < containerWidth){ // 切换条件
				//先划到scrollLeft为0的位置
				RightMar = setInterval(function(){
					for(var i = 0; i < 5; i++){
						if(tab.scrollLeft == 0){
							//改变scrollLeft到正确的位置，人眼看不到变化
							tab.scrollLeft = containerWidth * size;
							clearInterval(RightMar);
							RightMar = setInterval(function(){
								for(var j = 0; j < 5; j++){
									tab.scrollLeft--; 
									if(tab.scrollLeft == containerWidth * (size - 1)){
										clearInterval(RightMar);
										count = size - 1;
										setAnimationSwitch();
										swipeLock = false; 
										timer = (new Date()).getTime();
										setTimeout(function(){
											if((new Date()).getTime() - timer >= inter)
												playLock = false;
										}, inter);
										break;
									} 
								}
							}, speed);
							break;
						} 
						tab.scrollLeft--; 
					}
				}, speed);
			}else{
				var targetScrollLeft = count == 0 ? containerWidth * (size - 1) : containerWidth * (count - 1);
				RightMar = setInterval(function(){
					for(var i = 0; i < 5; i++){
						if(tab.scrollLeft == targetScrollLeft){
							clearInterval(RightMar);
							count = count == 0 ? size - 1 : count - 1;
							setAnimationSwitch();
							swipeLock = false; 
							timer = (new Date()).getTime();
							setTimeout(function(){
								if((new Date()).getTime() - timer >= inter)
									playLock = false;
							}, inter);
							break;
						}
						tab.scrollLeft--;
					}
				}, speed);
			}
		});
	}

    plg.delegate({
        onInstantiate: function(data, container){ 
			var queryArr, html, netData, that, fixedData = [];
			that = this;
			queryArr = [
				"uid=" + data.uid,
				"otype=2"
			];
			BMapCom.Loader.jsonp(online_api + queryArr.join("&"))
				.ok(function(result){
					netData = result.data;
					if(netData.code == 0 && netData.result.length > 0){
						fixedData = fixData(netData.result);
						html = that.template.body({list:fixedData});
						container.innerHTML = html; 
						styleFix(); 
						if(fixedData.length > 1)	
							playAnimation(5); 
					}
				})
				.error(function(){
					
				});
		}
	});
	
	return plg;
});
