BMapCom.Controller.create(function() {
    var isMonkey = BMapCom.config('monkeyTest');
    var recommend,nav,r1,r2,r3,find,seeMore,goto,data,currentTab=0,paramPage=null, seeMoreIntroduction;
    //var domain = 'http://cp01-rdqa-pool521.cp01.baidu.com:8081/phpui2/?';
    var domain = 'http://client.map.baidu.com/phpui2/?';
    //var domain = 'http://cp01-rdqa-pool383.cp01.baidu.com:8002/phpui2/?';
    var $ = function(q) {
        return document.querySelector(q);
    };
    var srcPage;
    function registerPage(from) {
        if (from) {
            srcPage = from + "_businessDetailPage";
        } else {
            srcPage = "businessDetailPage";
        }
    }
    var fixData = function(data){
        if(data.ext.detail_info.basic.image){
            //图片中存在已经进行过url编码的,防止2次编码
            data.ext.detail_info.basic.image = decodeURIComponent(data.ext.detail_info.basic.image);
            data.ext.detail_info.basic.image = encodeURIComponent(data.ext.detail_info.basic.image);
        }
        for(var i=0,tabLength=data.ext.detail_info.tab_list.length;i<tabLength;i++){
            for(var j=0,listLength=data.ext.detail_info[data.ext.detail_info.tab_list[i].id].hot_list.length;j<listLength;j++){
                data.ext.detail_info[data.ext.detail_info.tab_list[i].id].hot_list[j].image=encodeURIComponent(data.ext.detail_info[data.ext.detail_info.tab_list[i].id].hot_list[j].image);
            }
        }
    };
    var areaSourceDelegate = {
        search: function(uid){
            var self = this;
            var LOCAL_STORAGE_KEY = 'area-detail-page'+uid;
            var resultData = BMapCom.storage.getLocalStorage(LOCAL_STORAGE_KEY);
            if (resultData) {
                setTimeout(function() {
                    self.onSourceLoadFinish(resultData);
                }, 0);
            }else{
                BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID], function(runtimeInfo) {
                    var param = [
                        'qt=ninf',
                        'uid=' + uid,
                        'rp_filter=aoi',
                        'resid=01',
                        'point_x='+runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locX,
                        'point_y='+runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locY,
                        'from=webview'
                    ].join('&');

                    var url = domain + param;

                    return BMapCom.Loader.jsonp(url)
                        .ok(function(result) {
                            if (!result.errorNo) {
                                BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data.content, 5);
                                self.onSourceLoadFinish(result.data.content);
                            } else{
                                self.onSourceLoadFailed();
                            }
                        })
                        .error(function() {
                        //alert(url+'未返回数据');
                        self.onSourceLoadFailed();
                        });
                });
            };
            /*var param = [
                'qt=ninf',
                'uid=' + uid,
                'rp_filter=aoi',
                'point_x=12948582.14',
                'point_y=4836260',
                'resid=01',
                'from=webview'
            ].join('&');

            var url = domain + param;
            console.log(url);

            return BMapCom.Loader.jsonp(url)
                .ok(function(result) {
                    if ((!result.errorNo)&&result.data.content.ext.detail_info.basic) {
                        BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data.content, 5);
                        self.onSourceLoadFinish(result.data.content);
                    } else{
                        self.onSourceLoadFailed();
                    }
                })
                .error(function() {
                    self.onSourceLoadFailed();
                    console.log(url);
                });
            }*/
        }

    };
    //渲染页面
    var renderPage = function(page,tpl,result){
        page.append(tpl.body(result));
        page.$('#recommendList')[0].innerHTML=tpl.recommendListTpl(result.ext.detail_info[result.ext.detail_info.tab_list[0].id]);
        /*
        if (BMapCom.util.platform.isAndroid()) {
            var gotoNode = document.querySelector('.goto'), fixed, fixedNode = gotoNode.cloneNode(true);
            fixedNode.style.cssText = 'display:none;position:fixed;top:0;';
            document.body.appendChild(fixedNode);
            page.pageBody.onscroll = function(e) {
                var top = gotoNode.getBoundingClientRect().top
                if (top >= 0 && fixed) {
                    fixedNode.style.display = 'none';
                    fixed = false;
                } else if (top < 0 && !fixed) {
                    fixed = true
                    fixedNode.style.display = '';
                }
            }
        }
        */
        var descriptionText = document.getElementById('descriptionText');
        console.log(descriptionText.offsetHeight);
        console.log(descriptionText);            
        if (descriptionText.offsetHeight > 64) {
            descriptionText.className = 'description-text-fold';
            document.getElementsByClassName('seemore-introduction-panel')[0].innerHTML = "<div class='seemore-introduction'><p><span>查看更多</span><i class='toggle-arrow toggle-arrow-down'></i></p></div>";
        }
        if (BMapCom.util.platform.isAndroid()) {
            page.$("#placeHolder4a")[0].style.marginTop = "50px";
        }
    };
    //
    var initWidget = function(data){
        var base = data.ext.detail_info.basic;
        var widgetParam = {
            "uid": data.uid,
            "poi_name": base.name,
            "poi_addr": base.address,
            "poi_type": 0,
            "pt_x": parseInt(base.point_x),
            "pt_y": parseInt(base.point_y),
            "city_id": base.city_id
        }
        BMapCom.Kernel.notify('widget', {
            "wid": "poi_detail_header",
            "method": "init",
            "param": widgetParam
        });
    }
    //tab切换
    var changeNav = function(obj,page,tpl,result){
        if(obj.className.indexOf('active')>-1){
            return;
        }
        for(var i in nav){
            nav[i].className = '';
        }
        obj.className ='active';
        switch(obj.getAttribute('data-num')){
            case 'l1':
                page.$('#recommendList')[0].innerHTML=tpl.recommendListTpl(result.ext.detail_info[result.ext.detail_info.tab_list[0].id]);
                currentTab=0;
                break;
            case 'l2':
                page.$('#recommendList')[0].innerHTML=tpl.recommendListTpl(result.ext.detail_info[result.ext.detail_info.tab_list[1].id]);
                currentTab=1;
                break;
            case 'l3':
                page.$('#recommendList')[0].innerHTML=tpl.recommendListTpl(result.ext.detail_info[result.ext.detail_info.tab_list[2].id]);
                currentTab=2;
                break;
            default:
                break;
        }
    };
    //点击查看更多(排行榜)
    var recommendSeeMore = function(element,data){
        var businessTitle = data.ext.detail_info.basic.name+data.ext.detail_info.tab_list[currentTab].name+'排行榜';
        var entranceParam = {
            "page": 'rankPage',
            "pageParam": {
                //必传参数
                "uid": data.uid,
                "from": srcPage,
                'title': businessTitle,
                'option':{
                    'rank':0,
                    'aoi_name':data.ext.detail_info.basic.city_name+'|'+data.ext.detail_info.basic.area_name+'|'+data.ext.detail_info.basic.name,
                    'indus':data.ext.detail_info.tab_list[currentTab].id
                }
            }
        };
        //console.log(entranceParam);
        //console.log(data.ext.detail_info.basic.city_name+'|'+data.ext.detail_info.basic.area_name+'|'+data.ext.detail_info.basic.name);
        var seemorenum = currentTab+1;
        //console.log("mccaterbusinessdetailpg.seemore"+seemorenum);
        BMapCom.Stat.sendOffline("mccaterbusinessdetailpg.seemore"+seemorenum, {"da_model": "plugin_cater",'cat':'cater'});
        BMapCom.Kernel.notify('changePage', entranceParam);
    };
    //详情页跳转
    var recommendList = function(element){
        if (isMonkey) {
            return false;
        }
        var pageName;
        var id = document.querySelectorAll('.nav li')[currentTab].getAttribute('data-id');
        var tabName = document.querySelectorAll('.nav li')[currentTab].innerHTML;
        switch (id){
            case 'cater':
                pageName = 'caterPoiDetailPage';
                break;
            case 'hotel':
                pageName = 'hotelPoiDetailPage';
                break;
            case 'scope':
                pageName = 'sceneryPoiDetailPage';
                break;
            default:
                pageName = 'mainMapPoiDetailPage';
                break;
        }
        var entranceParam = {
            "page": pageName,
            "pageParam": {
                //必传参数
                "uid": element.getAttribute('uid'),
                "from": srcPage,
                "poiName":element.querySelector('.r-name').innerHTML,
                'industry':tabName
            }
        };
        //console.log(id);
        //console.log(entranceParam);
        //console.log(element.querySelector('.r-name').innerHTML);
        var detailnum = currentTab+1;
        //console.log("mccaterbusinessdetailpg.tablist"+detailnum);
        BMapCom.Stat.sendOffline("mccaterbusinessdetailpg.tablist"+detailnum, {"da_model": "plugin_cater",'cat':'cater'});
        BMapCom.Kernel.notify('changePage', entranceParam);
    };
    //列表页跳转(8块区域)
    var findIcon = function(element){
        if (isMonkey) {
            return false;
        }
        var entranceParam = {
            "page": 'poiListPage',
            "pageParam": {
                //必传参数
                "uid": element.getAttribute('uid'),
                "from": "businessDetailPage",
                'keyWord':element.getAttribute('industry'),
                'businessName':element.getAttribute('businessName'),
                'areaName':element.getAttribute('areaName')
            }
        };
        //console.log(entranceParam);
        //console.log(element.getAttribute('industry'));
        var clickNum = element.getAttribute('num');
        //console.log("mccaterbusinessdetailpg.otherindustry"+clickNum);
        BMapCom.Stat.sendOffline("mccaterbusinessdetailpg.otherindustry"+clickNum, {"da_model": "plugin_cater",'cat':'cater'});
        BMapCom.Kernel.notify('changePage', entranceParam);
    };
    //看过还看(其他商圈)
    var seeMoreList = function(element){
        var entranceParam = {
                    "page": "detailPage",
                    "pageParam": {
                        //必传参数
                        "uid": element.getAttribute('uid'),
                        "from": "businessDetailPage",
                        'businessName':element.querySelector('.list-basic-name').innerHTML
                    }
                };
        //console.log("mccaterbusinessdetailpg.otherbusiness");
        BMapCom.Stat.sendOffline("mccaterbusinessdetailpg.otherbusiness", {"da_model": "plugin_cater",'cat':'cater'});
        BMapCom.Kernel.notify('changePage', entranceParam);
    };
    //列表项描述展开和收起
    var recommendListDes = function(element){
        if(element.className == 'r-des'){
            element.className='r-des2'
            element.querySelector('p').className='text-ellipsis2';
        }else{
            element.className='r-des'
            element.querySelector('p').className='text-ellipsis';
        }
    };
    //搜周边
    var searchIcon = function(element,data){
        if (isMonkey) {
            return false;
        }
        var requestParam = {
            "category": "mainmap",
            "method": BMapCom.ComRequestMethod.DISPATCH,
            "param": {
                "target": "nearby_page",
                "base_params": {
                    "poi_name": data.ext.detail_info.basic.name,
                    "pt_x": parseInt(data.ext.detail_info.basic.point_x),
                    "pt_y": parseInt(data.ext.detail_info.basic.point_y)
                }
            }
        };
        //console.log('mccaterbusinessdetailpg.search');
        BMapCom.Stat.sendOffline("mccaterbusinessdetailpg.search", {"da_model": "plugin_cater",'cat':'cater'});
        BMapCom.Kernel.notify('request', requestParam);
    };
    //到这去
    var gotoIcon = function(element,data){
        if (isMonkey) {
            return false;
        }
        BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION, BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID], function(runtimeInfo) {
            var requestParam = {
                "category": "mainmap",
                "method": BMapCom.ComRequestMethod.DISPATCH,
                "param": {
                    "target": "route_search_page",
                    "base_params": {
                        "start_type": 1,
                        "start_keyword": "我的位置",
                        "start_longitude": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locX,
                        "start_latitude": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION].locY,
                        "start_city_id": runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.CITY_ID],
                        "end_type": 1,
                        "end_keyword": data.ext.detail_info.basic.name,
                        "end_longitude": parseInt(data.ext.detail_info.basic.point_x),
                        "end_latitude": parseInt(data.ext.detail_info.basic.point_y),
                        "end_uid": data.ext.detail_info.basic.uid,
                        "end_city_id": parseInt(data.ext.detail_info.basic.city_id,10)
                    }
                }
            };
            BMapCom.Stat.sendOffline("mccaterbusinessdetailpg.goto", {"da_model": "plugin_cater",'cat':'cater'});
            BMapCom.Kernel.notify('request', requestParam);
        });
    };
    var initElement = function(){
        recommend = new BMapCom.EventDelegater($('.recommend'));
        nav = document.querySelectorAll('.nav li');
        find = new BMapCom.EventDelegater($('.find'));
        seeMore = new BMapCom.EventDelegater($('.see-more'));
        if (BMapCom.util.platform.isAndroid()) {
            goto = new BMapCom.EventDelegater(document.body);
        } else {
            goto = new BMapCom.EventDelegater($('#detailPage'));
        }
        r1 = $('.r1');
        r2 = $('.r2');
        r3 = $('.r3');
        if($(".seemore-introduction-panel")){
            seeMoreIntroduction = new BMapCom.EventDelegater($(".seemore-introduction-panel"));
        }
    };
    var initEvent = function(data,page,tpl){
        goto.on('goBusinessDes:tap',function(e){
            if(this.className == 'description text-ellipsis'){
                this.className='description2 text-ellipsis2';
            }else{
                this.className='description text-ellipsis'
            }
        });
        goto.on('searchIcon:tap',function(e){
            //monkey
            searchIcon(this,data);
        });
        goto.on('gotoIcon:tap',function(e){
            //monkey
            gotoIcon(this,data);
        });
        //tab切换
        recommend.on('recommendNav:tap',function(e){
            //monkey
            changeNav(this,page,tpl,data);
        });
        //
        recommend.on('recommendList:tap',function(e){
            recommendList(this);
        });
        //推荐查看更多
        recommend.on('rSeeMoreLink:tap',function(e){
            recommendSeeMore(this,data);
        });
        recommend.on('recommendListDes:tap/stopPropagation',function(e){
            recommendListDes(this);
        });
        //
        find.on('findIcon:tap',function(e){
            //monkey
            findIcon(this);
        });
        //
        seeMore.on('seeMoreList:tap',function(e){
            seeMoreList(this);
        });
        if (seeMoreIntroduction) {
            seeMoreIntroduction.on('seeMoreIntroduction:tap',function(e){
                var descriptionText = document.getElementById('descriptionText');
                var toggleArrow = document.getElementsByClassName("toggle-arrow")[0];
                if (descriptionText.className == 'description-text-fold') {
                    descriptionText.className = 'description-text';
                    toggleArrow.className = 'toggle-arrow toggle-arrow-up';
                } else {
                    descriptionText.className = 'description-text-fold';
                    toggleArrow.className = 'toggle-arrow toggle-arrow-down';
                }
            });
        }
    };
    var initMethod = function(detailPage, detailTpl) {
        detailPage.pageContainer.setAttribute("style", "");
        detailPage.pageBody.setAttribute("style", "");
        var areaSource = new BMapCom.DataSource();
        //绑定数据对象代理
        areaSource
            .delegate(areaSourceDelegate)
            .delegate({
                onSourceLoadFinish: function(result) {
                    //detailPage.append(detailTpl.styleLink());
                    fixData(result);
                    try {
                        renderPage(detailPage, detailTpl, result);

                        initElement();
                        
                        initEvent(result,detailPage,detailTpl);
                        //monkey
                        initWidget(result);
                    } finally {
                        BMapCom.Kernel.notify('webPageReady');
                    }
                    registerPage(paramPage.from);
                    BMapCom.Stat.sendOnline({
                        "da_src": "mccaterbusinessdetailpg",
                        "da_act": "show",
                        "da_trd": "cater",
                        "da_model": "plugin_cater",
                        "da_src_page": paramPage.from,
                        "da_par": paramPage.from
                    });
                },
                onSourceLoadFailed: function(){
                    //console.log('数据格式未定义!');
                },
                startSourceLoad: function(uid) {
                    this.search(uid);
                }
            });


        detailPage.delegate({
            shouldWaiting: function() {
                return true;
            },
            onCreate: function(pageParam, ready) {
                paramPage = pageParam;
                areaSource.update(pageParam.uid);
            },
            onDestory: function() {

            }
        });

    }
    return {
        initWithPage: initMethod
    }
});


