(function (root) {
    var MONKEY_OPEN=false;
    var ONLINE_ENVIRONMENT=true;

    var URLS = {
        'REQUEST_WISE_OAT': {
            'online': 'http://map.baidu.com/hotel?qt=hotel_wise_ota',
            'debug': 'http://map.baidu.com/hotel?qt=hotel_wise_ota'
        },
        'REQUEST_QUNAR_OAT': {
            'online': 'http://map.baidu.com/hotel?qt=ota_order_price&src=qunar',
            'debug': 'http://map.baidu.com/hotel?qt=ota_order_price&src=qunar'
        },
        'REQUEST_HOUR_OAT': {
            'online': 'http://map.baidu.com/hotel?qt=ota_hour_price&src=qunar',
            'debug': 'http://map.baidu.com/hotel?qt=ota_hour_price&src=qunar'
        },

        'REQUEST_PHOTO_CARD': {
            'online': 'http://map.baidu.com/detail?qt=ugcphotolist',
            'debug': 'http://map.baidu.com/detail?qt=ugcphotolist'
        },
        'REQUEST_COMMENT_CARD': {
            'online': 'http://map.baidu.com/detail?qt=ugccmtlist',
            'debug': 'http://map.baidu.com/detail?qt=ugccmtlist'
        },
        'REQUEST_TUAN': {
            'online': 'http://openapi.se.nuomi.com/bnapi/api/query',
            'debug': 'http://openapi.se.nuomi.com/bnapi/api/query'
        },
        'REQUEST_HONGBAO_LIST': {
            'online': 'http://map.baidu.com/hotel?qt=hotel_list_hongbao',
            'debug': 'http://map.baidu.com/hotel?qt=hotel_list_hongbao'
        },
        'DI_REQUEST': {
            'online': 'http://map.baidu.com/detail?qt=sreview',
            'debug': 'http://map.baidu.com/detail?qt=sreview'
        },
        'STATIC_IMG_API': {
            'online': 'http://api.map.baidu.com/staticimage?',
            'debug': 'http://api.map.baidu.com/staticimage?'
        }
    }

    /* 详情页来源 */
    root.DETAIL_FROM = '';

    /* 路径统计参数 */
    root.PATH_INFO = {};

    /* 一个点的图片 */
    root.PIXEL_IMG = 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAMAAAAoyzS7AAAAA1BMVEUAAACnej3aAAAAAXRSTlMAQObYZgAAAA1JREFUeNoBAgD9/wAAAAIAAVMrnDAAAAAASUVORK5CYII=';

    /* 详情页版本 */
    root.DETAIL_VERSION  = 'webview_three_tab';

    /* 是否money */
    root.isMonkey = MONKEY_OPEN;

    /* window 上的绑定对象 */
    root.HOTEL_GLOBAL_OBJ = {};

    /* 通过变量绑定地址 */
    for (var key in URLS) {
        root[key] = ONLINE_ENVIRONMENT ? URLS[key].online : URLS[key].debug;
    }

})(window);
