BMapCom.AppCore.ready(function(entranceParam) {
    BMapCom.config('templateHtmlMode', false);
    BMapCom.config('monkeyTest', false);

    BMapCom.config('domain.map', "http://map.baidu.com/");
    BMapCom.config('domain.phpui', "http://client.map.baidu.com/phpui2/");
    BMapCom.config('domain.cater', BMapCom.config('domain.map') + "cater");
    BMapCom.config('domain.detail', "http://map.baidu.com/detail");
    BMapCom.config('domain.ugc', "http://i.map.baidu.com/");
    //BMapCom.config('domain.ugc', "http://cq01-rdqa-dev016.cq01.baidu.com:8011/");
    // BMapCom.config('domain.phpui', "http://cp01-rdqa-pool443.cp01.baidu.com:8000/phpui2/");
    //BMapCom.config('domain.phpui', "http://cq01-rdqa-pool213.cq01.baidu.com:8004/phpui2/");
    //BMapCom.config('domain.cater', "http://cp01-rdqa-pool443.cp01.baidu.com:8086/cater");

    //模拟native调用启动参数
    //入口协议解析
    BMapCom.Loader.script(["!zepto","!iscroll","!jsmod"]).ok(function(){
        if (entranceParam && entranceParam.page) {
            var pageParam = entranceParam.pageParam;
            switch (entranceParam.page) {
                case 'detailPage':
                    //param 还需要团购, 优惠, 订座, 外卖信息
                    if (pageParam && pageParam.uid && pageParam.from) {
                        //可传字段:pageParam.option.index
                        BMapCom.AppCore.changePage('detailPage', pageParam);
                    } else {
                        console.log('详情页入口参数错误');
                    }
                    break;
                case 'businessDetailPage':
                    //param 还需要团购, 优惠, 订座, 外卖信息
                    if (pageParam && pageParam.uid && pageParam.from) {
                        //可传字段:pageParam.option.index
                        BMapCom.AppCore.changePage('businessDetailPage', pageParam);
                    } else {
                        console.log('详情页入口参数错误');
                    }
                    break;
                case 'imagePage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('imagePage', pageParam);
                    } else {
                        console.log('图片页入口参数错误');
                    }
                    break;
                case 'bigImagePage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('bigImagePage', pageParam);
                    } else {
                        console.log('查看大图入口参数错误');
                    }
                    break;
                case 'introducePage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('introducePage', pageParam);
                    } else {
                        console.log('查看商户介绍页入口参数错误');
                    }
                    break;
                case 'merchantDetailPage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('merchantDetailPage', pageParam);
                    } else {
                        console.log('查看商户详情入口参数错误');
                    }
                    break;
                case 'recommendPage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('recommendPage', pageParam);
                    } else {
                        console.log('查看推荐菜入口参数错误');
                    }
                    break;
                 case 'recommendDetailPage':
                    if (pageParam) {
                        BMapCom.AppCore.changePage('recommendDetailPage', pageParam);
                    } else {
                        console.log('查看推荐菜详情入口参数错误');
                    }
                    break;
                case 'recommendImagePage':
                    if (pageParam && pageParam.option && pageParam.option.image) {
                        BMapCom.AppCore.changePage('recommendImagePage', pageParam);
                    } else {
                        console.log('查看推荐菜入口参数错误');
                    }
                    break;
                case 'caterRecommendPage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('caterRecommendPage', pageParam);
                    } else {
                        console.log('查看附近推荐美食入口参数错误');
                    }
                    break;
                case 'rankPage':
                    if (pageParam && pageParam.uid) {
                        BMapCom.AppCore.changePage('rankPage', pageParam);
                    } else {
                        console.log('查看排行榜入口参数错误');
                    }
                    break;
                case 'discountPage':
                    if (pageParam && pageParam.uid && pageParam.data) {
                        BMapCom.AppCore.changePage('discountPage', pageParam);
                    } else {
                        console.log('查看排行榜入口参数错误');
                    }
                    break;
                //主题详情页
                case 'topicDetailPage':
                    if (pageParam) {
                        BMapCom.AppCore.changePage('topicDetailPage', pageParam);
                    } else {
                        console.log('榜单详情页入口参数错误');
                    }
                    break;
                //排队详情页
                case 'queueOrderPage':
                    BMapCom.AppCore.changePage('queueOrderPage', pageParam);
                    break;
                //排队中心
                case 'userCenterPage':
                    BMapCom.AppCore.changePage('userCenterPage', pageParam);
                    break;
                //我的订单
                case 'myOrderPage':
                    BMapCom.AppCore.changePage('myOrderPage', pageParam);
                    break;
                //订单详情
                case 'orderDetailPage':
                    BMapCom.AppCore.changePage('orderDetailPage', pageParam);
                    break;
                // 更多评论
                case 'moreCommentPage':
                    window.BMapCom.AppCore.changePage('moreCommentPage', pageParam);
                    break;
                default:
                    console.log('未指定页面');
            }
            if (pageParam.ldata !== void 0 || pageParam.qid !== void 0 ) {
                window._ldata = pageParam.ldata || "";
                window._qid = pageParam.qid || "";
                localStorage.setItem('lsk-cater-ldata', window._ldata);
                localStorage.setItem('lsk-cater-qid', window._qid);
            } else {
                window._ldata = localStorage.getItem('lsk-cater-ldata') || "";
                window._qid = localStorage.getItem('lsk-cater-qid') || "";
            }
        }
    });
});
