BMapCom.Template.create("./plugin/MyCommentView/MyCommentViewTpl", {
body:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,userInfo=$data.userInfo,comments=$data.comments,total=$data.total,$escape=$helpers.$escape,$out=''; var userInfo = comments[0]; if (userInfo) { 
$out+='\n<div class="userinfo clearfix" ';
 if (total !== 1) {
$out+='data-ek="collapseMyComment" ';
 } 
$out+='>\n    <img src="http://map.baidu.com/maps/services/thumbnails?width=150&height=150&align=center,center&quality=100&src=';
$out+=$escape(userInfo.user_logo);
$out+='" alt="">\n    <div class="info-container"><i class="toggle-arrow"></i><p>我的评论<span>(共';
$out+=$escape( total);
$out+='条)</span></p><p class="name">';
$out+=$escape( userInfo.user_name);
$out+='</p></div>\n</div>\n';
 } 
$out+='\n<ul>\n\n</ul>';
return new String($out);
},
list:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,i=$data.i,length=$data.length,comments=$data.comments,$escape=$helpers.$escape,$out=''; for (var i = 0, length = comments.length; i < length; i++) { 
$out+='\n<li class="cv-comment-item">\n    <div class="cv-comment-user-basic">\n        <div class="cv-comment-user-rating ml0">\n            ';
 if(comments[i].ratingLevel) {
$out+='\n            <div class="cv-comment-user-rating-star cv-rating-star">\n                <b class="rating-star cv-rating-star-value" style="width:';
$out+=$escape(comments[i].ratingLevel);
$out+=';"></b>\n            </div>\n            ';
}
$out+='\n            ';
 if(comments[i].rating) {
$out+='\n            <span class="cv-comment-user-rating-text">';
$out+=$escape(comments[i].overall_rating);
$out+='</span>\n            ';
}
$out+='\n            ';
 if(comments[i].price) {
$out+='\n            <span class="cv-comment-user-price">人均&nbsp;&yen;&nbsp;';
$out+=$escape(comments[i].price);
$out+='</span>\n            ';
}
$out+='\n        </div>\n    </div>\n    ';
 if(comments[i].lessContent) {
$out+='\n        <div class="cv-comment-content" data-ek="arrowDown">';
$out+=$escape(comments[i].lessContent);
$out+='\n            <div class="cv-comment-arrow-container">\n                <span class="cv-comment-arrow down"></span>\n            </div>\n        </div>\n        <div class="cv-comment-content" data-ek="arrowUp" style="display:none;">\n            ';
$out+=$escape(comments[i].content);
$out+='\n            <div class="cv-comment-arrow-container">\n                <span class="cv-comment-arrow up"></span>\n            </div>\n        </div>\n    ';
}else{
$out+='\n        <div class="cv-comment-content">';
$out+=$escape(comments[i].content);
$out+='</div>\n    ';
}
$out+='\n    <div class="cv-comment-other">';
$out+=$escape(comments[i].date);
$out+='</div>\n</li>\n';
 } 
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var myDomainUrl = 'http://map.baidu.com/meishi?',
        gParam, gContext, gInstance, gResult;

    var fixComment = function(review, total) {
        var showMore = false;

        if (review && review.length) {
            if (gParam.startIndex == 0 && total > 10) {
                showMore = true;
            } else if (gParam.startIndex > 0 && (10 + gParam.startIndex * gParam.maxResults) <= total) {
                showMore = true;
            }
            var fixedData = {
                'showLoadMore': showMore,
                'comments': [],
                'total': 0
            };
            fixedData.comments = review.map(function(commentItem) {
                commentItem.username = commentItem.user_name || (commentItem.cn_name + '网友');
                commentItem.ratingLevel = (commentItem.overall_rating) ? commentItem.overall_rating * 20 + "%" : ((commentItem.overall_rating) ? commentItem.overall_rating * 20 + "%" : 0);
                commentItem.overall_rating = (commentItem.overall_rating) ? commentItem.overall_rating : ((commentItem.overall_rating) ? commentItem.overall_rating : 0);
                commentItem.content = commentItem.content.replace(/<\/?em.*?>/g, "");
                if (commentItem.content.length > 50) {
                    commentItem.lessContent = commentItem.content.substr(0, 50) + '...';
                }
                return commentItem;
            });

            fixedData.total = fixedData.comments.length;
            return fixedData;
        }
    };

    var myUgcSearchDelegator = {
        search: function(uid) {
            var self = this;
            BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, function(bduss) {
                if (!bduss) {
                    //bduss为空不请求
                    return null;
                }
                //var bduss = "p6dlBVWUZRV1NKdXM2OTY0T3hYc0tFZ342RkpzRm9Bd1FlU1NLc2tHRVhBVkpVQVFBQUFBJCQAAAAAAAAAAAEAAAB~WxwG0rvQ3dKyzebHuQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABd0KlQXdCpUUH";
                var param = [
                    'qt=ugc_myreview',
                    'poiId=' + uid,
                    'count=' + gParam.count,
                    'deviceFrom=map'
                ].join('&');
                return BMapCom.Loader.jsonp(myDomainUrl+param)
                    .ok(function(result) {
                        var data;
                        if(result.data && result.data.errno == 0 && result.data.data.cmt_count){
                            data = result.data.data;
                            self.onSourceLoadFinish(fixComment(data.cmt_info));
                        }
                    })
                    .error(function() {
                        self.onSourceLoadFailed();
                    });
            });
        }
    };
    var myUgcCommentSource = new BMapCom.DataSource();
    myUgcCommentSource
        .delegate(myUgcSearchDelegator)
        .delegate({
            startSourceLoad: function(uid) {
                this.search(uid);
            },
            onSourceLoadFinish: function(result) {
                gContext.style.display = "block";
                gResult = result;
                gResult.oneComment = gResult.comments.slice(0, 1);
                gResult.allComments = gResult.comments;
                gResult.comments = gResult.oneComment;
                gContext.innerHTML=gInstance.template.body(result);
                gContext.querySelector('ul').innerHTML = gInstance.template.list(result);
            },
            onSourceLoadFailed: function() {}
        });

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    plg.delegate({
        onInstantiate: function(options, context) {

            options.count = options.count || 10;

            gParam = options;

            gContext = context;

            gInstance = this;

            myUgcCommentSource.update(gParam.uid);

            var dispatcher = new BMapCom.EventDispatcher();

            var evt = new BMapCom.EventDelegater(context);
            evt.on('arrowDown:tap', function(e) {
                this.style.display = 'none';
                this.nextElementSibling.style.display = '';
            });
            evt.on('arrowUp:tap', function(e) {
                this.style.display = 'none';
                this.previousElementSibling.style.display = '';
            });

            evt.on('collapseMyComment:tap', function(e) {
                var arrow = gContext.querySelector("i.toggle-arrow");
                if (arrow.className === "toggle-arrow toggle-arrow-up") {
                    gResult.comments = gResult.oneComment;
                    gContext.querySelector('ul').innerHTML = gInstance.template.list(gResult);
                    arrow.className = "toggle-arrow";
                } else {
                    arrow.className = "toggle-arrow toggle-arrow-up"
                    gResult.comments = gResult.allComments;
                    gContext.querySelector('ul').innerHTML = gInstance.template.list(gResult);
                }
            });

            return {
                event: dispatcher,
                reload: function() {
                    this.clear();
                    myUgcSearchDelegator.update(gParam.uid);
                }
            };
        }
    });

    return plg;
});
