BMapCom.Template.create("./plugin/QueueView/QueueViewTpl", {
queueHeader:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$out='';$out+='<header class="with-icon with-right-arrow">排队取号</header>';
return new String($out);
},
queue:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,state=$data.state,queueNum=$data.queueNum,$escape=$helpers.$escape,notice=$data.notice,$out='';$out+='<header class="with-icon with-right-arrow">排队取号</header>\n<!--';
 if (state == 1 && queueNum == undefined) { 
$out+='\n<div class="clearfix status-none">\n    <p class="cl-gray">';
$out+=$escape( notice);
$out+='</p>\n</div>\n';
 } else if (state == 2 ) { 
$out+='\n<div class="clearfix status-none">\n    <p class="cl-gray">';
$out+=$escape( notice);
$out+='</p>\n</div>\n';
 } else if (state == 3 || (state == 1 && queueNum == 0)) { 
$out+='\n<div class="clearfix status-none">\n    <p class="cl-gray">';
$out+=$escape( notice);
$out+='</p>\n</div>\n';
 } else if (state == 4) { 
$out+='\n<div class="clearfix status-none">\n    <p class="cl-gray">';
$out+=$escape( notice);
$out+='</p>\n</div>\n';
 } else if (state == 5) { 
$out+='\n<div class="clearfix status-none">\n    <p class="cl-gray">';
$out+=$escape( notice);
$out+='</p>\n</div>\n';
 } else { 
$out+='\n<div class="clearfix status-none">\n    <span>前方</span><span class="cl-orange"><span class="fb f16">';
$out+=$escape( queueNum);
$out+='</span>桌</span>等待</span>\n    <div class="btnwrap"><span class="btn" data-ek="queue">取号</span></div>\n</div>\n';
 } 
$out+='-->';
return new String($out);
},
queuing:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,qnum=$data.qnum,qname=$data.qname,wait=$data.wait,waittime=$data.waittime,$out='';$out+='<header class="with-icon with-right-arrow">排队取号</header>\n<div class="clearfix status-queuing">\n    <div>\n        <p>\n            <span>我的号码: </span><span class="cl-orange"><span class="fb f16">';
$out+=$escape( qnum);
$out+='</span> ';
$out+=$escape( qname);
$out+='</span>\n        </p>\n        <p>前方<span class="cl-orange fb f16">';
$out+=$escape( wait || ' - ');
$out+='</span>桌等待';
 if(waittime) { 
$out+=', 预计等待<span class="cl-orange fb f16">';
$out+=$escape( waittime);
$out+='</span>';
 } 
$out+='</p>\n    </div>\n</div>';
return new String($out);
},
queuingOffline:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,qnum=$data.qnum,qname=$data.qname,$out='';$out+='<header class="with-icon with-right-arrow">排队取号</header>\n<div class="clearfix status-queuing">\n    <div>\n        <p>\n            <span>我的号码: </span><span class="cl-orange"><span class="fb f16">';
$out+=$escape( qnum);
$out+='</span> ';
$out+=$escape( qname);
$out+='</span>\n        </p>\n        <p>餐厅临时离线, 需现场确认</p>\n    </div>\n</div>';
return new String($out);
},
outdate:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,state=$data.state,$escape=$helpers.$escape,qnum=$data.qnum,qname=$data.qname,notice=$data.notice,shopState=$data.shopState,shopNotice=$data.shopNotice,queueNum=$data.queueNum,$out='';$out+='<header class="with-icon with-right-arrow">排队取号</header>\n<div class="clearfix status-outdate">\n    ';
 if (state === 6) { 
$out+='\n    <div>\n        <p>\n            <span>我的号码: </span><span class="cl-orange"><span class="fb f16">';
$out+=$escape( qnum);
$out+='</span> ';
$out+=$escape( qname);
$out+='</span>\n        </p>\n        <p>';
$out+=$escape( notice);
$out+='</p>\n    </div>\n    ';
 } else { 
$out+='\n    <div>\n        <p class="cl-gray">\n            我的号码: <span class="fb f16">';
$out+=$escape( qnum);
$out+='</span>\n        </p>\n        <p class="cl-orange">';
$out+=$escape( notice);
 if (shopState != 1) { 
$out+=' ';
$out+=$escape( shopNotice);
} else if (queueNum) { 
$out+=', <span>前方</span><span class="cl-orange"><span class="fb f16">';
$out+=$escape( queueNum||" - ");
$out+='</span>桌</span>等待</span></p>';
 } 
$out+='\n    </div>\n    ';
 if (shopState == 1) { 
$out+='\n    <div class="btnwrap"><span class="btn" data-ek="queue">取号</span></div>\n    ';
 }} 
$out+='\n</div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var STATUS = {
        "NONE": 0,        //未取号
        "QUEUING": 2,     //正在排号
        "ON_CALL": 4,     //正在叫好
        "TIMEOUT": 5,     //超时
        "ARRIVAL": 6,     //到店
        "OUTDATE": 7      //过号
    };

    var SHOP_STATUS = {
        "PHONE_QUEUE": 1,
        "ON_SITE_QUEUE": 2,
        "NO_NEED_QUEUE": 3,
        "CLOSED": 4,
        "OFFLINE": 5
    };

    var gParam, gContext, gInstance, gStatus = {
        "status": STATUS.NONE
    };

    var domain = BMapCom.config('domain.cater');
    var searchDelegator = {
        search: function(opts) {
            var self = this;
            var param = [
                'qt=queue_order_status',
                'sid=' + gParam.third_id,
                'sfrom=' + gParam.third_from
            ].join("&");
            return BMapCom.Loader.jsonp(domain + "?" + param)
                .ok(function(result) {
                    if (result.data.errno === 0) {
                        self.onSourceLoadFinish(result.data.result);
                    } else {
                        self.onSourceLoadFailed();
                    }
                })
                .error(function() {
                    self.onSourceLoadFailed();
                });
        }
    };
    
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
    var inited = false;

    function render(template, data) {
        data = data || {};

        gContext.innerHTML = template(data);

        if (!inited) {
            inited = true;
            gContext.style.display = 'block';
        }
    }

    function Interval(opt) {
        opt = opt || {};
        this._callback = [];
        this._intervalCode = -1;
        this._timeout = opt.timeout || 5000;
        
    }

    Interval.prototype.start = function() {
        if (this._intervalCode !== -1) {
            return this;
        }
        this._callback.forEach(function(item) {
            item.handler.call(item.context);
        });
        this._intervalCode = setInterval(function() {
            this._callback.forEach(function(item) {
                item.handler.call(item.context);
            });
        }.bind(this), this._timeout);
    };

    Interval.prototype.stop = function() {
        clearInterval(this._intervalCode);
        this._intervalCode !== -1;
    }

    Interval.prototype.add = function(obj) { // {handler: function(){}, context: {}}
        this._callback.push(obj);
        return this._callback - 1;
    }

    Interval.prototype.remove = function(pos) {
        if (pos > 0 && pos < this._callback.length) {
            this._callback.splice(pos, 1);
        }
    }

    plg.delegate({
        onInstantiate: function(options, context) {
            gInstance = this;
            gContext = context;
            gParam = options;
            
            _log({
                "da_src": "poidetailpg.queuebt",
                "da_act": "show"
            });

            var dispatcher = new BMapCom.EventDispatcher(),
                evt = new BMapCom.EventDelegater(context),
                queueSource = new BMapCom.DataSource(),
                exports = {};
            gParam.from = "caterDetailPage";
            evt.on("goQueuePage:tap", function(e) {
                BMapCom.Kernel.notify('changePage', {
                    "page": "queueOrderPage",
                    "pageParam" : gParam
                });

                _log("poidetailpg.queuebt");
            });
            exports.event = dispatcher;
            queueSource
                .delegate(searchDelegator)
                .delegate({
                    startSourceLoad: function(param) {
                        this.search(param);
                    },
                    onSourceLoadFinish: function(result) {
                        var userqueue = result.userqueue ? result.userqueue : null,
                            shopqueue = result.shopqueues;
                        render(gInstance.template.queueHeader, shopqueue);
                        /*if (shopqueue) {
                            //取排队人数
                            if (shopqueue.queues && shopqueue.queues.length) {
                                shopqueue.queueNum = shopqueue.queues.map(function(item) {
                                    return item.wait;
                                }).reduce(function(item1, item2) {
                                    return (item1 || 0) + (item2 || 0);
                                });
                            } else {
                                shopqueue.queueNum = void 0;
                            }

                            if (userqueue) {
                                //有排队状态
                                if (userqueue.state < STATUS.ARRIVAL && shopqueue.state != 1) { //如果是排队状态并且商户不可取号状态
                                    render(gInstance.template.queuingOffline, userqueue);  //突然离线
                                } else if (userqueue.state >= STATUS.ARRIVAL ) {            //成功到店或者过号 并且商户在线
                                    userqueue.shopState = shopqueue.state;userqueue.shopNotice = shopqueue.notice;
                                    if (shopqueue.queueNum) {
                                        userqueue.queueNum = shopqueue.queueNum;
                                    }
                                    render(gInstance.template.outdate, userqueue);
                                } else {                                                   //正常的排队中
                                    render(gInstance.template.queuing, userqueue);
                                }
                            } else {
                                //没有排队, 展示商家信息
                                render(gInstance.template.queue, shopqueue);
                            }

                            return ;
                        }*/
                    },
                    onSourceLoadFailed: function(result) {

                    }
                });
            function updateStatus() {
                BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION], function(runtimeInfo) {
                    var bduss = runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS],
                        loc = runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION];

                    gParam.bduss = bduss;
                    options.x = loc.locX;
                    options.y = loc.locY;
                    queueSource.update(options);

                });
            }

            var interval = new Interval({
                "timeout": 60000
            });
            interval.add({
                handler: updateStatus
            });

            interval.start();

            BMapCom.Kernel.listen('pollon', function() {
                updateStatus();
                interval.start();
            });

            BMapCom.Kernel.listen('polloff', function() {
                interval.stop();
            });
            return exports;
        }
    });

    return plg;
});
