BMapCom.Template.create("./plugin/RecommendView/RecommendViewTpl", {
groupon:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,g1=$data.g1,groupon=$data.groupon,$escape=$helpers.$escape,$out='';$out+='<div class="info-card cater-recommend groupon-list">\n    <header class="with-icon with-right-arrow" data-ek="goRecommendMore">附近团购</header>\n    <ul>\n        ';
 for(g1=0;g1<groupon.length;g1++){
$out+='\n            <li data-grouponid=\'';
$out+=$escape( groupon[g1].id);
$out+='\' data-ek=\'grouponLi\'>\n                <img src="';
$out+=$escape( groupon[g1].pic_url);
$out+='" width="60" height="47" onerror="this.src=\'style/img/cater_nodata.png\'">\n                <div>\n                    ';
 if (groupon[g1].groupon_brandtag && groupon[g1].groupon_short_title) { 
$out+='\n                    <p class=\'groupon-title ellipsis\'>【';
$out+=$escape( groupon[g1].groupon_brandtag);
$out+='】';
$out+=$escape( groupon[g1].groupon_short_title);
$out+='</p>\n                    ';
 } else {
$out+='\n                    <p class=\'groupon-title ellipsis\' style="text-indent: 4px;">';
$out+=$escape( groupon[g1].poi_title);
$out+='</p>\n                    ';
 } 
$out+='\n                    <p class="tips ellipsis">';
$out+=$escape(groupon[g1].group_title);
$out+='</p>\n                    <p class=\'groupon-price\'> <span class=\'price_yen\'>&yen;</span>';
$out+=$escape( groupon[g1].group_price ? groupon[g1].group_price : 0);
$out+='\n                        <span class="regular"> &yen;';
$out+=$escape( groupon[g1].regular_price ? groupon[g1].regular_price : 0);
$out+='</span>\n                        <span class="people">';
$out+=$escape( groupon[g1].sales);
$out+='人已购</span>\n                    </p>\n                </div>\n            </li>\n        ';
 }
$out+='\n    </ul>\n</div>';
return new String($out);
},
poilist:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,i=$data.i,list=$data.list,$escape=$helpers.$escape,$out='';$out+='<div class="info-card cater-recommend">\n    <header class=\'with-icon with-right-arrow\' data-ek="goRecommendMore">\n        <span class="recommendTitle-title">您可能还喜欢</span>\n    </header>\n    <ul>\n        ';
 for (var i = 0; i < list.length; i++) {
$out+='\n        <li data-ek="goDetail" data-uid="';
$out+=$escape(list[i].uid);
$out+='" data-name="';
$out+=$escape(list[i].title);
$out+='" data-from="rankList" class="ranklist-item">\n            <img src=';
 if (list[i].pic_url) {
$out+='"';
$out+=$escape(list[i].pic_url);
$out+='"';
} else {
$out+='"style/img/cater_nodata.png"';
 } 
$out+='alt="" width="75" height="58">\n            <div class="desc">\n                <h2>\n                    <span class="text-ellipsis">';
$out+=$escape(list[i].title);
$out+='</span>\n                    ';
 if (~list[i].state.indexOf("1")) { 
$out+='\n                    <i class="icon icon-groupon"></i>\n                    ';
 } if (~list[i].state.indexOf("6")){ 
$out+='\n                    <i class="icon icon-queue"></i>\n                    ';
 } if (~list[i].state.indexOf("5")){ 
$out+='\n                    <i class="icon icon-book"></i>\n                    ';
 } if (~list[i].state.indexOf("7")){ 
$out+='\n                    <i class="icon icon-takeout"></i>\n                    ';
 } if(~list[i].state.indexOf("2")){ 
$out+='\n                    <i class="icon icon-privilege"></i>\n                    ';
 } 
$out+='\n                </h2>\n                <p>\n                    ';
 if (+list[i].overall_rating) { 
$out+='<span class="star-text">';
$out+=$escape( (+list[i].overall_rating).toFixed(1) + "分");
$out+='</span>';
 } 
$out+='\n                    ';
 if (list[i].price) {
$out+='<span class="price">人均: &yen;';
$out+=$escape(list[i].price);
$out+='</span>';
}
$out+='\n                </p>\n                <p class="f12 mt5 cl-gray">\n                    <span class="distance">';
$out+=$escape(list[i].distance > 1000 ? (list[i].distance/1000).toFixed(1) + "km" : list[i].distance > 0 ? list[i].distance + "m": "");
$out+='</span>\n                    ';
$out+=$escape( list[i].sq);
$out+=' ';
$out+=$escape( list[i].std_tag);
$out+='\n                </p>\n            </div>\n        </li>\n        ';
 } 
$out+='\n    </ul>\n</div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var gParam, gContext, gInstance;
    var _log;

    function search(success, fail) {
        var self = this;
        BMapCom.SysApi.getRuntimeInfo([BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS, BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION], function(runtimeInfo) {
            BMapCom.SysApi.getSystemInfo(BMapCom.SysApi.SYSTEM_INFO_TYPE.CUID, function(cuid) {
                var bduss = runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.BDUSS],
                    loc = runtimeInfo[BMapCom.SysApi.RUNTIME_INFO_TYPE.LOCATION];
                gParam.cuid = cuid;
                gParam.locX = loc.locX;
                gParam.locY = loc.locY;
                var domain = BMapCom.config('domain.cater'),//"http://cp01-rdqa-pool521.cp01.baidu.com:8086/cater?",
                    param = [
                    'qt=poi_recommend',
                    'uid=' + gParam.uid,
                    'nb_x=' + loc.locX,
                    'nb_y=' + loc.locY,
                    'useridtype=na',
                    'userid=' + cuid
                ].join('&');

                var url = domain + '?' + param;

                return BMapCom.Loader.jsonp(url)
                    .ok(function(result) {
                        if (result.data.errno === 0) {
                            success(result.data.data);
                        } else {
                            BMapCom.Loader.jsonp(url)
                                .ok(function(result){
                                    if(result.data.errno === 0 && result.data.total){
                                        success(result.data.data);
                                    }
                                });
                        }
                    })
                    .error(function() {
                        fail && fail();
                    });
            });
        });
    };

    
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    
    plg.delegate({
        onInstantiate: function(options, context) {
            gInstance = this;
            gContext = context;
            gParam = options;
            
            var dispatcher = new BMapCom.EventDispatcher();
            search(function(result) {
                var content = [];
                var src;
                if (result.type === "groupon") {
                    src = 'poidetailpg.recommendgroupon';
                    content = result.content.slice(0, 2);
                    content.forEach(function(item) {
                        item.pic_url = BMapCom.util.getThumbUrl(encodeURIComponent(item.pic_url), 140, 100);
                    });
                    context.innerHTML = gInstance.template.groupon({groupon: content});
                } else if (result.type === "sametag" || result.type === "relative") {
                    src = 'poidetailpg.recommendpoi.' + result.type;
                    content = result.content.slice(0, 2);
                    content.forEach(function(item) {
                        item.pic_url = BMapCom.util.getThumbUrl(encodeURIComponent(item.pic_url), 140, 100);
                    });
                    context.innerHTML = gInstance.template.poilist({list: content});
                }
                if (!content.length) {
                    return ;
                }
                _log = Logger.get({
                    da_src: src, da_act: "click", x: gParam.locX, y: gParam.locY, uid: gParam.uid,
                    da_model: 'plugin_cater', da_trd: 'cater', uniq_id: result.uniqueid,
                    da_abtest: result.exp, userid: gParam.cuid, qid: window._qid, ldata: window._ldata
                });
                _log({da_act: 'show', limit: 2});
            });

            var evt = new BMapCom.EventDelegater(context);
            //团购展开收起
            evt.on('showAll:tap',function(e) {

            });

            //团购详情
            evt.on('grouponLi:tap',function(e){
                if (BMapCom.config("isMonkey")) {
                    return false;
                }
                var requestParam = {
                    category: "groupon",
                    method: BMapCom.ComRequestMethod.DISPATCH,
                    param: {
                        "target": "target_groupon_detail",
                        "base_params": {
                            "key_detail_dealid": this.getAttribute('data-grouponid'),
                            "src_channel": "map_cater",
                            "qid": _qid,
                            "ldata": _ldata
                        }
                    }
                };
                 
                _log({click_id: this.getAttribute('data-grouponid')});

                BMapCom.Kernel.notify("request", requestParam, function(result){});

            });
            
            evt.on("goDetail:tap", function() {

                 var entranceParam = {
                    "page": "detailPage",
                    "pageParam": {
                        "uid": this.getAttribute("data-uid"),
                        "from": "caterDetailPage",
                        "option": {
                            
                        }
                    }
                };

                BMapCom.Kernel.notify('changePage', entranceParam);

                _log({click_id: this.getAttribute("data-uid")});
            });

            evt.on("goRecommendMore:tap", function(e) {
                var entranceParam = {
                    "page": "caterRecommendPage",
                    "pageParam": {
                        "uid": gParam.uid,
                        option: {
                        }
                    }
                };
                _log("poidetailpg.moreresbt");
                BMapCom.Kernel.notify('changePage', entranceParam);
            });

            return {
                event: dispatcher
            };
        }
    });

    return plg;
});
