BMapCom.Template.create("ScopeTicketViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,hasMore=$data.hasMore,list=$data.list,t=$data.t,$escape=$helpers.$escape,tag=$data.tag,$out='';$out+='<div class="scope-tickets-header">\r\n		门票预订\r\n		';
 if(hasMore) {
$out+='\r\n		<div class="scope-more-tickets-btn" data-ek="scopeMoreTicketsBtn">查看更多</div>\r\n		';
 } 
$out+='\r\n	</div>\r\n	<div class="scope-tickets-list">\r\n		';
list.forEach(function(t){
$out+='\r\n		<section class="scope-ticket-item">\r\n			<div class="scope-left-cont" data-ticketid="';
$out+=$escape(t.ticket_id);
$out+='" data-ek="scopeTicketNoticeBtn">\r\n				<h6 class="scope-ticket-title">';
$out+=$escape(t.name);
$out+='</h6>\r\n				<div class="scope-ticket-tips">\r\n					';
 t.tags.forEach(function(tag){
$out+='\r\n					<span>';
$out+=$escape(tag);
$out+='</span>\r\n					';
})
$out+='\r\n				</div>\r\n				<div class="scope-ticket-notice-btn">预订须知</div>\r\n			</div>\r\n			<div class="scope-right-cont">\r\n				<div class="scope-right-wrap">\r\n					<div class="scope-price-cont">\r\n						';
if(t.market_price>t.price) {
$out+='\r\n						<span class="scope-original-price">&yen;';
$out+=$escape(t.market_price);
$out+='</span>\r\n						';
}
$out+='\r\n						<span class="scope-unit">&yen;</span>\r\n						<span class="scope-price">';
$out+=$escape(t.price);
$out+='</span>\r\n					</div>\r\n					<a class="scope-book-btn" data-ticketid="';
$out+=$escape(t.ticket_id);
$out+='" href="javascript:void(0)"><div class="scope-book-ticket-btn" data-ticketid="';
$out+=$escape(t.ticket_id);
$out+='" data-ek="scopeTicketBookBtn">预订</div></a>\r\n				</div>\r\n			</div>\r\n		</section>\r\n		';
})
$out+='\r\n	</div>\r\n    <div class="notice-popup-warp">\r\n        <div class="popup-header mod-dialog-header-wrap">\r\n            <span>预订须知</span>\r\n            <span class="btn-close" data-ek="noticeCloseBtn"></span>\r\n        </div>\r\n        <div class="mod-dialog-iscroll-wrap">\r\n        	<div class="popup-content"></div>\r\n        </div>\r\n        <div class="popup-footer mod-dialog-footer-wrap">\r\n            <div class="btn-book" data-ek="noticePayBtn">\r\n                <span style="font-size: 12px">&yen;</span>\r\n                <span class="price">0</span>\r\n                <span class="book">立即预订</span>\r\n            </div>\r\n        </div>\r\n    </div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
	var plg = PluginBuilder.create({
		hasTemplate: true,
		hasCSS: true
	});

	var cacheParams;

	//加载相关类库
	var loadJS = function(fn) {
		var needJS = [];
		if (!window.Zepto) {
			needJS.push('!zepto');
		}
		if (!window.IScroll) {
			needJS.push('!iscroll');
		}
		if (!window.jsmod) {
			needJS.push('!jsmod');
		}
		if (needJS.length) {
			BMapCom.Loader.script(needJS).ok(fn);
		} else {
			fn();
		}
		
	}

	var getTickets = function(container, uid) {
		// 远程取得数据景点门票数据
		$.ajax({
			url: "http://map.baidu.com/scope?qt=ticket_list",
			dataType: "jsonp",
			data: {
				uid: cacheParams.uid,
				from: "webview",
				request_from: BMapCom.util.platform.isAndroid() ? 'android' : 'iphone',
				v: "1.0",
				resid: "01"
			},
			timeout: 5000,
			success: function(data) {
				if (data.err_no == 0 && data.data.length > 0) {
					container.show();
					Tickets.init(container, data.data);
					//展示酒店锚点
				    if (cacheParams.order_from == 'map_hotel') {
				    	setTimeout(function() {
				    		$('.hotel-base-right').length && $('.hotel-base-right').show();
				    	});
				    }
				}
			}
		});
	}

	var Tickets = {
		init: function(container, data) {
			var self = this;

			self.tickets = {}; //门票信息
			self.container = container;
			self.render(plg.template.body, self.doData(data));

			//预订须知
			self.wrapNotice = $(".notice-popup-warp");
			self.dg = new jsmod.ui.Dialog({
				element: self.wrapNotice,
				isIScroll: true,
				width: document.body.clientWidth - 20,
				height: "70%"
			});

			var evt = new BMapCom.EventDelegater(self.container.get(0));
			self.initEvents(evt);
		},

		//渲染页面
		render: function(template, data) {
			var self = this;
			this.container.html(template(data));

			//门票展现统计
			var src = "";
			for (var k in self.tickets) {
				if (self.tickets.hasOwnProperty(k) && self.tickets[k]) {
					var partner_id = self.tickets[k].partner_id;
					src = partner_id.split("_")[0];
					break;
				}
			}
			var orderbookFroms = {
				'ctripticket': 'poiDetailPG.' + cacheParams.orderFrom + '.sealTicketCtripticket',
				'qunar': 'poiDetailPG.' + cacheParams.orderFrom + '.sealTicketQunar',
				'changlong': 'poiDetailPG.' + cacheParams.orderFrom + '.sealTicketChanglong'
			}
			BMapCom.Stat.sendOnline({
				da_src: orderbookFroms[src],
				da_trd: "scope",
				da_act: "show",
				da_model: "plugin_scenery"
			});
		},

		//修复数据
		doData: function(list) {
			var ret = {
				hasMore: false,
				list: []
			};
			var self = this;
			if (list && list.length > 0) {
				ret.hasMore = list.length > 3 ? true : false;
				ret.list = list.slice(0, 3).map(function(t) {
					self.tickets[t.ticket_id] = t;
					return {
						ticket_id: t.ticket_id,
						tags: t.tag.split('|'),
						name: t.name,
						price: t.price,
						market_price: t.market_price
					};
				});
			}
			return ret;
		},

		//设置预订须知内容
		setNoticeContent: function(ticketid) {
			var html = "",
				ticket = this.tickets[ticketid];
			ticket.tip.forEach(function(e) {
				html += '<div class="scope-notice-title">' + e.title + '</div>';
				html += '<div class="scope-notice-content">' + e.content.join('<br>') + '</div>'
			});
			this.wrapNotice.find('.popup-content').html(html);
			this.wrapNotice.find('.btn-book').data('ticketid', ticketid);
			this.wrapNotice.find('.price').html(ticket.price);
		},

		//预订
		bookTicket: function(ticketid, from) {
			if (BMapCom.config('monkeyTest')) {
				return false;
			}

			var o = this.tickets[ticketid];
			var src = o.partner_id.split('_')[0];
			var noticbooks = {
				'ctripticket': 'poiDetailPG.' + cacheParams.orderFrom + '.sealOrderBookCtripticket',
				'qunar': 'poiDetailPG.' + cacheParams.orderFrom + '.sealOrderBookQunar',
				'changlong': 'poiDetailPG.' + cacheParams.orderFrom + '.sealOrderBookChanglong'
			};
			
			var entranceParam = {
				"category": "scenery",
				"method": BMapCom.ComRequestMethod.DISPATCH,
				"param": {
					"target": "scenery_order_fillout_request",
					"base_params": {
						"partner_id": src,
						"scope_id": o.scope_id,
						"scope_name": o.name,
						"ticket_id": o.ticket_id,
						"bid": cacheParams.uid,
						"extra": o.extra,
						order_from: cacheParams.order_from,
						src_from: cacheParams.src_from,
						qid: cacheParams.qid
					}
				}
			};

			if (src in noticbooks) {
				BMapCom.Stat.sendOnline({
					da_src: noticbooks[src],
					da_trd: "scope",
					da_act: "click",
					da_model: "plugin_scenery",
					src_from: cacheParams.src_from,
					qid: cacheParams.qid
				});
			}
			
			BMapCom.Kernel.notify('request', entranceParam);
		},

		initEvents: function(evt) {
			var self = this;
			// 预订须知
			evt.on("scopeTicketNoticeBtn:tap", function() {
				var ticketid = $(this).attr("data-ticketid");
				self.setNoticeContent(ticketid);
				//统计
				BMapCom.Stat.sendOnline({
					da_src: 'poiDetailPG.' + cacheParams.orderFrom + '.ticketNoticeBtn',
					da_trd: "scope",
					da_act: "click",
					da_model: "plugin_scenery",
				});
				self.dg.show();
			});

			//预订
			evt.on("scopeTicketBookBtn:tap", function() {
				var orderid = $(this).attr("data-ticketid");
				self.bookTicket(orderid, 'detail');
			});

			//查看更多门票
			evt.on("scopeMoreTicketsBtn:tap", function() {
				if (BMapCom.config('monkeyTest')) {
					return false;
				}
				var partner_id = "partner_list=";
				for (var k in self.tickets) {
					if (self.tickets.hasOwnProperty(k) && self.tickets[k]) {
						partner_id += self.tickets[k].partner_id;
						break;
					}
				}
				var entranceParam = {
					"category": "scenery",
					"method": BMapCom.ComRequestMethod.DISPATCH,
					"param": {
						"target": "scenery_booklist_request",
						"base_params": {
							"uid": cacheParams.uid,
							"src": partner_id,
							order_from: cacheParams.order_from,
							src_from: cacheParams.src_from,
							qid: cacheParams.qid
						}
					}
				};
				BMapCom.Stat.sendOnline({
					da_src: "poiDetailPG." + cacheParams.orderFrom + ".moreticketbt",
					da_trd: "scope",
					da_act: "click",
					da_model: "plugin_scenery",
				});
				BMapCom.Kernel.notify('request', entranceParam);
			});

			//关闭预订须知
			self.wrapNotice.find('.btn-close').on("tap", function() {
				self.dg.hide();
				self.dg.iscroll.scrollTo(0, 0);
			});

			//立即支付
			self.wrapNotice.find('.btn-book').on("tap", function() {
				var orderid = $(this).attr("data-ticketid");
				self.dg.hide();
				self.bookTicket(orderid, 'detailNotice');
			});
		}
	};

	plg.delegate({
		onInstantiate: function(baseData, container) {
			cacheParams = baseData;
			cacheParams.orderFrom = cacheParams.order_from ? cacheParams.order_from.replace(/[_-](\w{1})/g, function(a,b){ return b.toLocaleUpperCase()}) : 'mapScope';

			loadJS(function(){
				container = $(container)
				if (container.length>0 && cacheParams.uid) {
					getTickets(container, baseData.uid);
				}
			});
		}
	});
	return plg;
});