BMapCom.Template.create("./plugin/SimpleCommentView/SimpleCommentViewTpl", {
comments:function ($data,$id
/**/) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,commentNum=$data.commentNum,impression=$data.impression,i=$data.i,j=$data.j,comments=$data.comments,$out='';$out+='<div class="info-card simple-comments" data-ek="goCommentTab">\n        <header class="with-icon with-right-arrow">评论<span class="comment-num">(';
$out+=$escape( commentNum);
$out+='条)</span></header>\n        ';
 if (impression && impression.length > 0) { 
$out+='\n            <section class="impression">\n                <ul>\n                    ';
 for (var i = 0; i < impression.length; i++) { 
$out+='\n                        <li class="';
$out+=$escape( impression[i].keyword_type === 1 ? 'active' : '');
$out+='">\n                            ';
$out+=$escape( impression[i].keyword);
$out+='\n                            <span>';
$out+=$escape( impression[i].keyword_num);
$out+='</span>\n                        </li>\n                    ';
 } 
$out+='\n                </ul>\n            </section>\n        ';
 } 
$out+='\n        <section class="comments">\n            <ul>\n                <ul>\n                    ';
 for (var j = 0; j < comments.length && j < 2; j++) { 
$out+='\n                        <li>\n                            <header class="name">\n                                <span>';
$out+=$escape( comments[j].name);
$out+='</span>\n                                ';
 if (comments[j].isDaren) { 
$out+='\n                                    <span class="daren">达人</span>\n                                ';
 } else { 
$out+='\n                                    <!--<span class="rating">评分: <em class="orange-color">';
$out+=$escape( comments[j].overall_rating);
$out+='</em></span>-->\n                                    <span class="rating-star">\n                                        <b class="rating-star-value" style="width:';
$out+=$escape( comments[j].overall_rating);
$out+='%;"></b>\n                                    </span>\n                                ';
 } 
$out+='\n                            </header>\n                            <p class="simple-comment">';
$out+=$escape( comments[j].content);
$out+='</p>\n                        </li>\n                    ';
 } 
$out+='\n                </ul>\n            </ul>\n        </section>\n    </div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var gParam, gContent, gData = [];
    // 判断时候加载了用户评论（区别于达人评论）
    var isLoadComments = false;

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    var loadData = function () {
        var param = {
            qt: "ugc_masterreview",
            from: "webview",
            uid: gParam.uid
        };

        BMapCom.Loader.jsonp(BMapCom.config('domain.cater') + "?" + $.param(param)).ok(function (result) {
            if (result.data.errno !== 0 || result.data.data.length === 0) {
                loadComments();
                return ;
            }

            // var LOCAL_STORAGE_KEY = "lsk-cater-detail-plugin-comments" + gParam.uid;
            // BMapCom.storage.setLocalStorage(LOCAL_STORAGE_KEY, result.data, 1);

            fixData(result.data.data);
        });
    };

    var loadComments = function () {
        var param = {
            'qt': 'ugccmtlist',
            'uid': gParam.uid,
            'type': 'cater',
            'pageIndex': 1,
            'pageCount': 2,
            'orderBy': 1,
            'from': 'mapclient'
        };

        BMapCom.Loader.jsonp(BMapCom.config('domain.map') + "detail?" + $.param(param)).ok(function (result) {
            isLoadComments = true;
            if (result.data.errorNo !== 0 || result.data.comment.comment_num === 0) {
                return;
            }

            fixData(result.data.comment.comment_list);
        });
    };

    var fixData = function (data) {
        gData = gData.concat(data);

        // 如果达人评论不足两条则加载用户评论
        if (gData.length < 2 && isLoadComments == false) {
            loadComments();
            return;
        }

        gData.forEach(function(item) {
            if (item.master_name) {
                item.name = item.master_name;
                item.isDaren = true;
                return;
            }

            item.name = item.user_name;
            if (item.overall_rating) {
                item.overall_rating = parseFloat(item.overall_rating).toFixed(1) * 20;
            }
        });


        renderPage({impression: gParam.impression, comments: gData, commentNum: gParam.commentNum});
    };

    var renderPage = function (data) {
        gContent.innerHTML = plg.template.comments(data);
    };

    plg.delegate({
        onInstantiate: function(options, context) {

            gParam = options;
            gContent = context;

            var dispatcher = new BMapCom.EventDispatcher();

            loadData();

            var evt = new BMapCom.EventDelegater(context);
            evt.on("goCommentTab:tap", function (e) {
                dispatcher.fire('goCommentTabClick', []);
            });

            return {
                event: dispatcher
            };
        }
    });



    return plg;
});