BMapCom.Template.create("SlideViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$out='';$out+='<div class="image-list-container" id="imageListContainer">\n        <ul class="image-list-scroller" id="imageListScroller">\n        </ul>\n    </div>';
return new String($out);
},
imageItem:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,$escape=$helpers.$escape,width=$data.width,height=$data.height,show=$data.show,imageUrl=$data.imageUrl,lessComment=$data.lessComment,comment=$data.comment,cnName=$data.cnName,userName=$data.userName,$out='';$out+='<li class="sv-it-li">\n        <div class="sv-it-main" style="width: ';
$out+=$escape(width);
$out+='px; height: ';
$out+=$escape(height);
$out+='px;">\n            <div class="sv-it-img-container">\n                ';
if(show){
$out+='\n                    <img class="sv-it-img" src="';
$out+=$escape(imageUrl);
$out+='" style="margin-top: 48px;">\n                ';
}else{
$out+='\n                    <img class="sv-it-img" style="margin-top: 48px;">\n                ';
}
$out+='\n            </div>\n            <div class="sv-it-info">\n                <div class="sv-it-comment">\n                    ';
 if(lessComment) {
$out+='\n                        <div>\n                            <span>';
$out+=$escape(lessComment);
$out+='</span>\n                            <span class="sv-it-comment-more" data-ek=\'commentMore\'>更多</span>\n                        </div>\n                        <div style="display:none;">\n                            <span>';
$out+=$escape(comment);
$out+='</span>\n                            <span class="sv-it-comment-less" data-ek=\'commentLess\'>收起</span>\n                        </div>\n                    ';
}else{
$out+='\n                        <p>';
$out+=$escape(comment);
$out+='</p>\n                    ';
}
$out+='\n                </div>\n                <p class="sv-it-info-more">\n                    <span class="sv-it-comment-cn">来自';
$out+=$escape(cnName);
$out+='</span>\n                    ';
 if (userName) {
$out+='\n                        <span class="sv-it-comment-username">用户：';
$out+=$escape(userName);
$out+='</span>\n                    ';
}
$out+='\n                </p>\n            </div>\n        </div>\n    </li>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var util = BMapCom.util; 

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });

    var imgOnloadHandler = function() {
        this.onload = null;
        //按比例缩放
        fitImageSize(this);
        this.style.display = "inline";
    }

    var imgOnerrorHandler = function() {
        this.parentNode.style.display = 'none';
        this.onerror = null;
    }

    var liWidth;
    var liHeight;

    var fitImageSize = function(img) {
        var iwidth = document.body.clientWidth - 20;
        //20为上下留边
        var iheight = liHeight - 65 - 20;
        var topHei = BMapCom.util.platform.isIPhone() ? 0 : 10;

        if (img.width > 0 && img.height > 0) {
            if (img.width / img.height >= iwidth / iheight) {
                if (img.width > iwidth) {
                    img.height = (img.height * iwidth) / img.width;
                    img.width = iwidth;
                }
            } else {
                if (img.height > iheight) {
                    img.width = (img.width * iheight) / img.height;
                    img.height = iheight;
                }
            }
            img.style.marginTop = ((iheight - img.height) / 2 - topHei) + 'px';
        }
    }

    plg.delegate({
        onInstantiate: function(imageData, context) {
            var self = this;

            context.innerHTML = this.template.body({});

            var scrollContainer = context.querySelector('#imageListContainer');
            var scrollScroller = context.querySelector('#imageListScroller');


            var renderPlugin = function(liWidth, liHeight) {
                var listHTML = [];
                imageData.index = parseInt(imageData.index,10);

                imageData.forEach(function(item,index) {
                    item.width = liWidth;
                    item.height = liHeight;
                    if(Math.abs(index-imageData.index) <= 1)
                        item.show = true;
                    item.imageUrl = util.getThumbUrl(item.imageUrl, 2000, 2000); 
                    listHTML.push(self.template.imageItem(item));
                });
                scrollScroller.innerHTML = listHTML.join('');
                scrollScroller.style.width = imageData.length * liWidth + 'px';

                var imageElements = scrollScroller.getElementsByTagName('img');
                var imageShow = [];
                for (var i = 0, n = imageElements.length; i < n; i++) {
                    imageElements[i].style.display = "none";
                    imageElements[i].onload = imgOnloadHandler;
                    imageElements[i].onerror = imgOnerrorHandler;
                    imageShow.push(false);
                }
                imageShow[imageData.index] = true;
                if(imageData.index > 0) 
                    imageShow[imageData.index-1] = true;
                if(imageData.index < imageShow.length - 1)
                    imageShow[imageData.index+1] = true;

                self.iScroll = new BMapCom.iScroll(scrollContainer, {
                    snap: true,
                    momentum: false,
                    hScrollbar: false,
                    x: -(liWidth * imageData.index),
                    currPageX: imageData.index
                }, function(x){
                    var idx = parseInt((-x) / liWidth, 10);                    
                    var minidx = Math.max(0, idx-1);
                    var maxidx = Math.min(idx+1, imageShow.length-1);
                    var i;
                    for(i = minidx; i <= maxidx; i++){
                        if(!imageShow[i]){
                           imageElements[i].src = imageData[i].imageUrl;
                           imageShow[i] = true;
                        }    
                    }
                });

                self.iScroll.refresh();

            }

            liWidth = document.body.clientWidth;
            liHeight = document.body.clientHeight;

            if (liHeight == 0) {
                BMapCom.SysApi.getRuntimeInfo(BMapCom.SysApi.RUNTIME_INFO_TYPE.VIEWPORT, function(viewport) {
                    liHeight = viewport.height;
                    renderPlugin(liWidth, liHeight);
                });
            } else {
                renderPlugin(liWidth, liHeight);
            }

        }
    });

    return plg;
});