BMapCom.Template.create("ZDHViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,i=$data.i,n=$data.n,data=$data.data,$escape=$helpers.$escape,k=$data.k,m=$data.m,j=$data.j,l=$data.l,$out='';for (i = 0, n = data.length > 3 ? 3 : data.length; i < n; i++ ){ 
$out+='\n    <div class="zdh-container" style="';
$out+=$escape(i < 2 ? 'margin-bottom:7px;' : '');
$out+='">\n        ';
if(i == 0){
$out+='\n        <div class="zdh-title">直达商户</div>\n        <div class="line_split"></div>\n        ';
}
$out+='\n            <div class="zdh-item">\n                <div class="zdh-body" data-ek="zdhClick" data-url=';
$out+=$escape(data[i].url);
$out+=' data-appid=';
$out+=$escape(data[i].app_id);
$out+='>\n                    <div class="zdh-icon"><img src="';
$out+=$escape(data[i].logo);
$out+='" style="width:100%;height:100%;border-radius:4px;"/></div>\n                    <div class="zdh-name">@ ';
$out+=$escape(data[i].name);
$out+='</div>\n                    ';
if(data[i].sales){
$out+='\n                    <div class="zdh-sales">\n                        ';
for (k = 0, m = data[i].promotion_data.length; k < m; k++ ){ 
$out+='\n                        <span>';
$out+=$escape(data[i].promotion_data[k]);
$out+='</span>\n                        ';
}
$out+='\n                    </div>\n                    ';
}
$out+='\n                    <div class="';
$out+=$escape(data[i].sales?'zdh-desc-single':'zdh-desc');
$out+='">';
$out+=$escape(data[i].summary);
$out+='</div>\n                </div>\n                ';
if(data[i].service_data && data[i].service_data.length){
$out+='\n                <div class="zdh-btns">\n                ';
for (j = 0, l = data[i].service_data.length; j < l; j++){ 
$out+='\n                <div class="zdh-btns-item" style="width:';
$out+=$escape(100/l);
$out+='%" data-ek="zdhBtnClick" data-index=';
$out+=$escape(i + '.' + j);
$out+=' data-appid=';
$out+=$escape(data[i].app_id);
$out+='><span><span class="zdh-btns-icon" style="background:url(\'';
$out+=$escape(data[i].service_data[j].icon_url);
$out+='\') no-repeat center center;background-size:14px;vertical-align:-2px;"></span>';
$out+=$escape(data[i].service_data[j].title);
$out+='</span></div>\n                ';
}
$out+='\n                </div>\n                ';
}
$out+='\n            </div>\n        ';
if(0){ 
$out+='\n            <div class="zdh-foot" data-ek="zdhMore"><span>查看全部</span><div class="zdh-more-down"></div></div>\n        ';
}
$out+='\n    </div>\n    ';
}
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {

    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
    plg.delegate({
        onInstantiate: function(poiInfo, context) {

            if(!navigator.userAgent.toUpperCase().match(/ANDROID/)) return;

            var poiInfo = poiInfo;
            if(!poiInfo || !poiInfo.appid) return;

            var self = this;
            var source = new BMapCom.DataSource();
            //绑定数据对象代理
            source
                .delegate({
                    search: function(appid) {

                        var self = this;

                        var url = "http://openapi.baidu.com/public/2.0/lightservice/map?app_ids=" + appid;

                        return BMapCom.Loader.jsonp(url)
                            .ok(function(result) {
                                self.onSourceLoadFinish(result);
                            })
                            .error(function() {

                            });
                    }
                })
                .delegate({
                    onSourceLoadFinish: function(vm) {

                        if(!vm.data || !vm.data.length) return;

                        BMapCom.Stat.sendOffline('PoiDPG.ZDH.show',{
                            "da_model" : "plugin_" + poiInfo.src_name
                        });

                        var data = [];
                        var isPro = false;
                        for(var i = 0; i < vm.data.length; i++){
                            var item = vm.data[i];
                            if (item.name) {
                                item.sales = item.promotion_data && item.promotion_data[0] || '';
                                item.sales && (isPro = true);
                                data.push(item);
                            }
                        }
                        if(!data.length) return;

                        if (isPro) {
                            BMapCom.Stat.sendOffline('PoiDPG.ZDH.promotionShow', {
                                da_model: 'plugin_' + poiInfo.src_name
                            });
                        }

                        context.innerHTML = self.template.body({"data" : data});

                        var evt = new BMapCom.EventDelegater(context);
                        /*
                        evt.on('zdhMore:tap', function(e) {
                            var first = this.firstChild;
                            var last = this.lastChild;
                            if(last.className.indexOf('down') != -1){
                                last.className = 'zdh-more-up';
                                first.innerText = "收起全部";
                            }else{
                                last.className = 'zdh-more-down';
                                first.innerText = "查看全部";
                            }
                            Array.prototype.forEach.call(document.querySelectorAll('[data-sign]'), function(o, i){
                                if(last.className.indexOf('down') != -1){
                                    o.style.display = 'none';
                                }else{
                                    o.style.display = 'block';
                                }
                            });
                            
                            
                        });
                        */
                        evt.on('zdhClick:tap', function(e) {
                            BMapCom.Stat.sendOffline('PoiDPG.ZDH.click', {
                                da_model: 'plugin_' + poiInfo.src_name,
                                appid: this.getAttribute('data-appid')
                            });

                            var requestParam = {
                                "category": "o2ozone",
                                "method": BMapCom.ComRequestMethod.DISPATCH,
                                "param": {
                                    "target": "dispatch_o2o_mainpage",
                                    "base_params": {
                                        "url" : this.getAttribute('data-url')
                                    }
                                }
                            };
                            BMapCom.Kernel.notify('request', requestParam);
                        });
                        evt.on('zdhBtnClick:tap', function (e) {

                            var index = this.getAttribute('data-index');
                            var splits = index.split('.');
                            var item = data[splits[0]].service_data[splits[1]];

                            BMapCom.Stat.sendOffline('PoiDPG.ZDH.btnClick', {
                                da_model: 'plugin_' + poiInfo.src_name,
                                appid: this.getAttribute('data-appid'),
                                type: item.key
                            });

                            if (item.type === 'tel') {
                                BMapCom.SysApi.tel(item.href);
                            }else if (item.type === 'url') {
                                var requestParam = {
                                    category: 'o2ozone',
                                    method: BMapCom.ComRequestMethod.DISPATCH,
                                    param: {
                                        target: 'dispatch_o2o_mainpage',
                                        base_params: {
                                            url: item.href
                                        }
                                    }
                                };
                                BMapCom.Kernel.notify('request', requestParam);
                            }
                        });

                    },
                    startSourceLoad: function(appid) {
                        this.search(appid);
                    }
                });

            source.update(poiInfo.appid);
        }
    });

    return plg;
});