BMapCom.Template.create("ZDNoticeViewTpl", {
body:function ($data,$id) {
var $helpers=BMapCom.Template.helpers,list=$data.list,i=$data.i,$escape=$helpers.$escape,$out='';$out+='<div class=\'noticeBody\'>\n		<p class=\'noticeHead\' data-ek=\'seeMoreNotice\'>\n			公告栏\n			';
if(list.length > 0){
$out+='\n			<span class=\'noticeMore\'>全部</span>\n			';
}
$out+='\n			<span class=\'noticeArrow\' data-ek=\'seeMoreNotice\'></span>\n		</p>\n		<ul class=\'noticeList\'>\n			';
if(list.length > 0){
$out+='\n				';
for(var i = 0; i < list.length; i++){
$out+='\n					<li data-ek=\'seeNoticeDetail\' index=';
$out+=$escape(i);
$out+='>\n						【';
$out+=$escape(list[i].type);
$out+='】';
$out+=$escape(list[i].title);
$out+='\n					</li>\n				';
}
$out+='\n			';
}else{
$out+='\n				<li style="color:#999">暂无新公告</li>\n			';
}
$out+='\n		</ul>\n	</div>';
return new String($out);
}});
BMapCom.Plugin.define(function(PluginBuilder) {
    var plg = PluginBuilder.create({
        hasTemplate: true,
        hasCSS: true
    });
	var online_api = "http://elbc.baidu.com/zdh/announcement/";
	//var online_api = "http://cq02-map-sv-control04.cq02.baidu.com:8999/zdh/Announcement/"; // rd_address
	//var online_api = "http://cp01-qa-junheng2-qa123.cp01.baidu.com:8999/zdh/Announcement/"; // qa_address

	function fixnd(data){
		var maps = ['', '新品', '满减', '红包', '优惠', '活动', '满送'];
		for(var i = 0; i < data.length; i++){
			data[i].type = maps[data[i].type];
		}
		return data;
	}
	plg.delegate({
		onInstantiate:function(paramObj, container){
			var params = [ 
				'uid=' + paramObj.uid,
			]; 
			var that = this;
			BMapCom.Loader.jsonp(online_api + 'getlist?' + params.join("&"))
				.ok(function(result){
					if(result.data.code == 0){
						var fixNoticeData = fixnd(result.data.result);
						var html = that.template.body({list:fixNoticeData}); 
						container.innerHTML = html;
						if(fixNoticeData.length == 0){
							return;
						}
						var dispatcher = new BMapCom.EventDispatcher(); 
						var evt = new BMapCom.EventDelegater(container); 
						evt.on('seeMoreNotice:tap', function(e){
							var requestParam = {
								"category": "mainmap",
								"method": BMapCom.ComRequestMethod.DISPATCH,
								"param": {
									"target": "poi_deep_detail_page",
									"base_params": {
										"param": {
											"page": "noticeListPage",
											"pageTitle": "公告列表",
											"pageParam":{
												"uid": paramObj.uid,
												"name": paramObj.name,
												"headimg": paramObj.headimg || '',
												"from": "detailPage" 
											}
										}
									}
								}
							}; 
							BMapCom.Kernel.notify('request', requestParam, function(result) {}); 
            				BMapCom.Stat.sendOnline({
								'da_src': 'noticelistpg.morelistshow',
								'da_act': 'click',
								'da_trd': 'zhidahao'
							});
						});
						evt.on('seeNoticeDetail:tap', function(e){
							var self = this;
			                var index = self.getAttribute('index');
							var requestParam = {
								"category": "mainmap",
								"method": BMapCom.ComRequestMethod.DISPATCH,
								"param": {
									"target": "poi_deep_detail_page",
									"base_params": {
										"param": {
											"page": "noticeDetailPage",
											"pageTitle": "公告详情",
											"pageParam":{
												"uid": paramObj.uid,
												"name": paramObj.name,
												"msgid": fixNoticeData[index].id,
												"headimg": paramObj.headimg || '',
												"from": "detailPage" 
											}
										}
									}
								}
							};
							BMapCom.Kernel.notify('request', requestParam, function(result) {}); 
							
            				BMapCom.Stat.sendOnline({
								'da_src': 'noticelistpg.itemshow',
								'da_act': 'click',
								'da_trd': 'zhidahao'
							});
						});
					}
				})
				.error(function(){
					
				});
	  	}
	});

	return plg;
});
